#########################################################################
# COPYRIGHT (C) 2003         EDF R&D              WWW.CODE-ASTER.ORG    #
#                                                                       #
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR         #
# MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS        #
# PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE    #
# LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                       #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,       #
# BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF        #
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      #
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              #
#                                                                       #
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     #
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,       #
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.        #
#########################################################################
#$Id: asjob_main.tcl,v 1.53 2003/05/26 12:04:37 mcourtoi Exp $
# Environnement graphique de suivi des excutions
#
#### ==========
proc asjob_main {{root .}} {
#### ==========
#   on est normalement sous ASTK/ASTK_CLIENT/lib/ASJOB
#
   init_asjob
   set asjob::fen_root $root
   wm title    $asjob::fen_root [ashare::mess ihm 137 $astk::astk_version]
   wm iconname $asjob::fen_root [ashare::mess ihm 137 $astk::astk_version]
   wm protocol $asjob::fen_root WM_DELETE_WINDOW { set asjob::actu(indic) 0;destroy $asjob::fen_root }
   if { $asjob::fen_root == "." } {
      set main .main
   } else {
      set main $asjob::fen_root.main
   }
   eval destroy [winfo child $asjob::fen_root]
   affiche_main $main
}
#### =========
proc ajout_job { args } {
#### =========
#
# verif que asjob est lanc si appel par astk
   show_fen $astk::ihm(asjob)
#
   set iret 4
   lire_job asjob::TextJobs $asjob::NomSuivi
   set retour [eval insert_job asjob::TextJobs $args]
   if { $retour > 0 } {
      sauv_job asjob::TextJobs $asjob::NomSuivi
      lbxLoadFile $asjob::window.suivi.ftx1.lbx $asjob::NomSuivi
      $asjob::window.suivi.ftx1.lbx yview end
      set iret 0
   }
   return $iret
}
#### ============
proc loadStateJob {w} {
#### ============
#
#  Examine l'ensemble des travaux affichs dans le suivi, slectionne ceux dans l'tat different de
#  "ENDED" et envoie la commande d'actualisation sur chacun d'eux
#
   set asjob::status ""
   lire_job asjob::TextJobs $asjob::NomSuivi
   set nb_jobs [array size asjob::TextJobs]
   if { $nb_jobs > 0 } {
      set id [array startsearch asjob::TextJobs]
      for {set i 0} {$i < $nb_jobs} {incr i} {
         set elt [array nextelement asjob::TextJobs $id]
         set valjob [lindex [array get asjob::TextJobs $elt] 1]
         set etajob [lindex $valjob [lindex $asjob::paraJob(etat) 0]]
         if { $etajob != "ENDED" } {
            set machexe  [lindex [lindex [array get asjob::TextJobs $elt] 1] [lindex $asjob::paraJob(machine) 0]]
            set user     [lindex [lindex [array get asjob::TextJobs $elt] 1] [lindex $asjob::paraJob(user) 0]]
            set num      [lindex [lindex [array get asjob::TextJobs $elt] 1] [lindex $asjob::paraJob(numero) 0]]
            set nom      [lindex [lindex [array get asjob::TextJobs $elt] 1] [lindex $asjob::paraJob(nom) 0]]
            set mode     [lindex [lindex [array get asjob::TextJobs $elt] 1] [lindex $asjob::paraJob(mode) 0]]
            set tcpu_av  [lindex [lindex [array get asjob::TextJobs $elt] 1] [lindex $asjob::paraJob(tcpu) 0]]
            set noeud_av [lindex [lindex [array get asjob::TextJobs $elt] 1] [lindex $asjob::paraJob(noeud) 0]]

         #  On envoie la commande sur le serveur permettant de rcuprer l'tat du job et on actualise les paramtres
            set retour -1
            if { [valid_serveur $machexe nom_complet] } {
               set repSrv $astk::config($astk::inv(cmpl,$machexe,$user),rep_serv)
               set retour [ashare::rexec_cmd $astk::inv(cmpl,$machexe,$user) astk::config "$repSrv/as_serv" "as_actu $num $nom $mode" 0 out $asjob::fen_root]
               if { $ashare::dbg > 1 } {
                  ashare::log "<DEBUG> (loadStateJob) retour=$retour out=$out"
               }
            } else {
               ashare::mess erreur 11 $machexe
            }
	         if { $retour == 0 } {
	            if { [regexp {DIAG[ ]*=[ ]*([-a-z_A-Z0-9<>?*+=]+)} $out match diag] == 0 } { set diag "_" }
               if { [regexp {TCPU[ ]*=[ ]*([0-9_]+)} $out match tcpu] == 0 } { set tcpu "_" }
	            if { $tcpu == "_" }  {set tcpu $tcpu_av}
               if { [regexp {ETAT[ ]*=[ ]*([a-z_A-Z]+)}  $out match etat] == 0 } { set etat "_" }
               if { [regexp {EXEC[ ]*=[ ]*([a-z_A-Z.0-9]+)} $out match noeud] == 0 } { set noeud "_" }
	            if { $noeud == "_" }  { set noeud $noeud_av }
               set j1 [lindex $asjob::paraJob(diagnostic) 0]
               set valjob [lreplace $valjob $j1 $j1 $diag]
               set j1 [lindex $asjob::paraJob(etat) 0]
               set valjob [lreplace $valjob $j1 $j1 $etat]
               set j1 [lindex $asjob::paraJob(tcpu) 0]
               set valjob [lreplace $valjob $j1 $j1 $tcpu]
               set j1 [lindex $asjob::paraJob(noeud) 0]
               set valjob [lreplace $valjob $j1 $j1 $noeud]
               array set asjob::TextJobs [list $num $valjob]
	         } else {
               set asjob::status "<ERREUR> accs $num $nom impossible, Code retour : $retour"
	         }
         }
      }
      array donesearch asjob::TextJobs $id
      sauv_job asjob::TextJobs $asjob::NomSuivi
      lbxLoadFile $w $asjob::NomSuivi
      $w yview end
   }
}
#### =========
proc suppr_job { w } {
#### =========
   if { [$w curselection] == "" } {
      set asjob::status "<ALARME> Slectionner tout d'abord un job !"
      bell
   } else {
      set indsel [lsort -decreasing -integer [$w curselection]]
      for {set i 0} {$i < [llength $indsel]} {incr i} {
         set nsel [lindex $indsel $i]
         set sel  [lindex $asjob::Jobs $nsel]
         set nom     [lindex $sel [lindex $asjob::paraJob(nom) 0]]
         set num     [lindex $sel [lindex $asjob::paraJob(numero) 0]]
         set etajob  [lindex $sel [lindex $asjob::paraJob(etat) 0]]
         set machexe [lindex $sel [lindex $asjob::paraJob(machine) 0]]
         set noeud   [lindex $sel [lindex $asjob::paraJob(noeud) 0]]
         set user    [lindex $sel [lindex $asjob::paraJob(user) 0]]
         set mode    [lindex $sel [lindex $asjob::paraJob(mode) 0]]

      # on appelle le service permettant d'interrompre le job as_del
         if { $etajob != "ENDED" } {
            set confirm [tk_messageBox -title [ashare::mess ihm 143] -message [ashare::mess ihm 249 $num] -type yesno -icon question -parent $asjob::fen_root]
         } else {
            set confirm "yes"
         }
         if { $confirm == "yes" } {
            set retour -1
            if { [valid_serveur $machexe nom_complet] } {
               set repSrv $astk::config($astk::inv(cmpl,$machexe,$user),rep_serv)
               set retour [ashare::rexec_cmd $astk::inv(cmpl,$machexe,$user) astk::config $repSrv/as_serv "as_del $num $nom $mode $noeud" 0 out $asjob::fen_root]
               if { $ashare::dbg > 1 } {
                 ashare::log "<DEBUG> (suppr_job) retour= $retour out=$out"
               }
            } else {
               ashare::mess erreur 11 $machexe
            }
            if { $retour != 0 && $retour != -1 } {
              set asjob::status "<ERREUR> Suppression $num $nom impossible, Code retour : $retour"
            } else {
              lire_job asjob::TextJobs $asjob::NomSuivi
              eval delete_job asjob::TextJobs $num
              sauv_job asjob::TextJobs $asjob::NomSuivi
              lbxLoadFile $w $asjob::NomSuivi
              $w yview end
            }
         }
      }
      $w selection set $nsel
   }
}
#                    -------------------------------------------------------
#### ========
proc loadInfo {} {
#### ========
   set finfo .finfo
   catch {destroy $finfo}
   toplevel $finfo
   wm title $finfo "Informations et version"
   frame $finfo.ftx
   text $finfo.ftx.tx -xscrollcommand "$finfo.ftx.scrollx set" -yscrollcommand "$finfo.ftx.scrolly set" \
           -height 12 -width 80 -font $astk::ihm(font,txt) -bg white -setgrid true
   scrollbar $finfo.ftx.scrolly -command "$finfo.ftx.tx yview"
   scrollbar $finfo.ftx.scrollx -command "$finfo.ftx.tx xview" -orient h

   pack $finfo.ftx.scrolly -side right  -fill y
   pack $finfo.ftx.scrollx -side bottom -fill x
   pack $finfo.ftx.tx -expand yes -fill both
   pack $finfo.ftx -expand yes -fill both
   button $finfo.quitter -text "Ok" -command "destroy $finfo"
   pack $finfo.quitter
   if { [file exists $asjob::ficInfo] } {
      textLoadFile $finfo.ftx.tx $asjob::ficInfo
   }
}
#### ============
proc a_propos_asjob { parent } {
#### ============
   set fen .fen_about
   catch {destroy $fen}
   toplevel $fen
   wm title $fen "[ashare::mess ihm 105] - [ashare::mess ihm 106]"
   wm geometry $fen "+300+200"
   wm transient $fen $parent
   grab set $fen

#  titre
   pack [frame $fen.titre -relief raised -bd 1] -anchor c -fill x -expand 1
   label $fen.titre.lbl -font $astk::ihm(font,tit) -text [ashare::mess ihm 137 $astk::astk_version] -anchor w
   pack $fen.titre.lbl -padx 20 -pady 10

#  texte
   pack [frame $fen.txt -relief raised -bd 1] -anchor c -fill x -expand 1
   label $fen.txt.bla -font $astk::ihm(font,txt) -text [ashare::mess ihm 108] -anchor w
   pack $fen.txt.bla -padx 20 -pady 10

#  fermer
   pack [frame $fen.valid -relief solid -bd 0]
   button $fen.valid.ok -font $astk::ihm(font,labbout) -text "Ok" -command "destroy $fen ; grab release $fen"
   pack $fen.valid.ok -padx 10 -pady 3
}
#### ============
proc textLoadFile {w file} {
#### ============
# Cette procdure permet de charger le contenu du fichier "file" dans un
# widget de type Text.
#
# Arguments:
# w    :	Nom d'une fenetre de type text
# file :	Nom du fichier  charger
   if [file exist $file] {
      set f [open $file]
      $w delete 1.0 end
      while {![eof $f]} {
         $w insert end [read $f 10000]
      }
      close $f
   }
}
#### ===========
proc lbxLoadFile {w file} {
#### ===========
# Cette procdure permet de charger le contenu du fichier "file" dans un
# widget de type Listbox.
#
# Arguments:
# w    :	Nom d'une Listbox
# file :	Nom du fichier  charger
   if [file exist $file] {
      set f [open $file]
      $w delete 0 end
      while {![eof $f]} {
         set line ""
         if { [gets $f line] > 0 } {$w insert end $line}
      }
      close $f
   }
}
#### ==========
proc editJobSel {w type} {
#### ==========
# edition du job selectionne
# Arguments:
# w : widget listbox
# type      output/error
#
   global env

   if { [$w curselection] == "" } {
      set asjob::status "<ALARME> Slectionner tout d'abord un job !"
      bell
   } else {
      set indsel [$w curselection]
      for {set i 0} {$i < [llength $indsel]} {incr i} {
         set nsel [lindex $indsel $i]
         set sel  [lindex $asjob::Jobs $nsel]
      # on appelle le service as_edit
         set num     [lindex $sel [lindex $asjob::paraJob(numero) 0]]
         set nom     [lindex $sel [lindex $asjob::paraJob(nom) 0]]
         set mode    [lindex $sel [lindex $asjob::paraJob(mode) 0]]
         set machexe [lindex $sel [lindex $asjob::paraJob(machine) 0]]
         set user    [lindex $sel [lindex $asjob::paraJob(user) 0]]
         set etat    [lindex $sel [lindex $asjob::paraJob(etat) 0]]
         if { $etat == "ENDED" } {
            set retour -1
            if { [valid_serveur $machexe nom_complet] } {
               set repSrv $astk::config($astk::inv(cmpl,$machexe,$user),rep_serv)
               set display $ashare::DISPLAY
               set retour [ashare::rexec_cmd $astk::inv(cmpl,$machexe,$user) astk::config $repSrv/as_serv "as_edit $num $nom $mode $type $display" 1 out $asjob::fen_root]
               if { $ashare::dbg > 1 } {
                 ashare::log "<DEBUG> (editJobSel) retour= $retour out=$out"
               }
            } else {
               ashare::mess erreur 11 $machexe
            }
            if { $retour != 0 } {
               set asjob::status "<ERREUR> Edition $num $nom Code retour : $retour"
            } else {
               set asjob::status "<INFO> Edition $num $nom"
            }
         } else {
            set asjob::status "<ALARME> tat du job = $etat"
         }
      }
   }
}
#### ==========
proc tailJobSel { w } {
#### ==========
# edition du job selectionne
# Arguments:
# w : widget listbox
   global expr_tail
#
   if { [$w curselection] == "" } {
      set asjob::status "<ALARME> Slectionner tout d'abord un job !"
      bell
   } else {
      set indsel [$w curselection]
      set nsel   [lindex $indsel 0]
      $w selection clear 0 end
      $w selection set $nsel
      set sel  [lindex $asjob::Jobs $nsel]
  #
  # on appelle le service as_tail
  #
      set num     [lindex $sel [lindex $asjob::paraJob(numero) 0]]
      set nom     [lindex $sel [lindex $asjob::paraJob(nom) 0]]
      set mode    [lindex $sel [lindex $asjob::paraJob(mode) 0]]
      set machexe [lindex $sel [lindex $asjob::paraJob(machine) 0]]
      set user    [lindex $sel [lindex $asjob::paraJob(user) 0]]
      set etat    [lindex $sel [lindex $asjob::paraJob(etat) 0]]
      if { $etat == "RUN" } {
         set nb        $astk::config(-1,nb_ligne)
         set output    [file join $astk::tmpdir output]
         file delete -force $output
         if { [ashare::meme_machine $astk::config(-1,nom_complet) $machexe] 
           && $astk::config(-1,login) == $user } {
            set r_output  "$output"
         } else {
            set r_output  "$astk::config(-1,login)@$astk::config(-1,nom_complet):$output"
         }
         set retour -1
         if { [valid_serveur $machexe nom_complet] } {
            set repSrv $astk::config($astk::inv(cmpl,$machexe,$user),rep_serv)
            set retour [ashare::rexec_cmd $astk::inv(cmpl,$machexe,$user) astk::config $repSrv/as_serv "as_tail $num $nom $mode $r_output $nb $expr_tail" 0 out $asjob::fen_root]
            if { $ashare::dbg > 1 } {
               ashare::log "<DEBUG> (tailJobSel) retour= $retour out=$out"
            }
         } else {
            ashare::mess erreur 11 $machexe
         }
         if { $retour != 0 } {
            set asjob::status "<ERREUR> Consultation  $num $nom Code retour : $retour"
         } else {
            set asjob::status "<INFO> Consultation  $num $nom"
            textLoadFile $asjob::window.ftx2.lbx2 $output
            $asjob::window.ftx2.lbx2 yview end
         }
      } else {
        set asjob::status "<ALARME> tat du job = $etat"
      }
   }
}
#### ============
proc reactu_jobs  { } {
#### ============
   if { $asjob::actu(indic) == 1 && $astk::config(-1,freq_actu) > 0 } {
      loadStateJob $asjob::actu(f_actu)
      if { $ashare::dbg > 1 } {
         ashare::log "<DEBUG> (reactu_jobs) actu(id_after)=$asjob::actu(id_after) freq_actu=$astk::config(-1,freq_actu)"
      }
      set val_ms [expr $astk::config(-1,freq_actu) * 60 * 1000]
      set asjob::actu(id_after) [after $val_ms {reactu_jobs}]
   } else {
      if { $asjob::actu(id_after) > 0 } {
         after cancel $asjob::actu(id_after)
         set asjob::actu(id_after) 0
      }
   }
}
#### ============
proc affiche_main { w } {
#### ============
#
#  Affichage de la fenetre principale contenant :
#     1 - barre de status (widget label)
#     2 - barre de menu  (widget menu)
#     3 - ensemble de boutons (widget button)
#     4 - zone d'affichage des jobs (widget listbox)
#     5 - ligne de texte de recherche (widget entry)
#     6 - zone d'affichage du contenu des fichiers (widget listbox)
#
   set asjob::actu(f_actu) $w.suivi.ftx1.lbx
   set asjob::actu(id_after) 0

   set but_fnt  $astk::ihm(font,labbout)
   set lbx_fnt  $astk::ihm(font,txtfix)

   set asjob::window $w

   destroy $w
   pack [frame $w -bd 0] -expand yes -fill both
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Barre de status : affichage des erreurs, alarmes et informations
#     status :  contient le message  afficher
   set menustatus "    "
   frame $w.statusBar
   label $w.statusBar.label -textvariable asjob::status -relief sunken -bd 1 -font $lbx_fnt -anchor w
   pack $w.statusBar.label -side left -padx 2 -expand yes -fill both
   pack $w.statusBar -side bottom -fill x -pady 2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Barre de menus
#
   set fm $w.fm
   frame $fm -relief raised -bd 1
   pack  $fm -side top -fill x

   set m $fm.file.m
   menubutton $fm.file -text [ashare::mess ihm 26] -underline 0 -menu $m
   menu $m -tearoff 0 -bd 1
   $m add command -label [ashare::mess ihm 32] -command "set asjob::actu(indic) 0;destroy $asjob::fen_root" -underline 0
   pack $fm.file -side left
   set ashare::context($m,0) 127
# aide contextuelle
#   bind $m <<MenuSelect>> "ShowStatus menu $m asjob"
#   set mo $fm.opt.m
#   menubutton $fm.opt -text [ashare::mess ihm 33] -underline 0 -menu $mo
#   menu $mo -tearoff 0 -bd 1
#   $mo add command -label "[ashare::mess ihm 37]..." -underline 0 -command "Opt_prefs"
#   pack $fm.opt -side left
#   set ashare::context($mo,0) 131
# aide contextuelle
#   bind $mo <<MenuSelect>> "ShowStatus menu $mo asjob"
   set mh $fm.help.m
   menubutton $fm.help -text [ashare::mess ihm 105] -underline 0 -menu $mh
   menu $mh -tearoff 0 -bd 1
   $mh add command -label "[ashare::mess ihm 138]..." -underline 0 -command "loadInfo"
   $mh add separator
   $mh add command -label "[ashare::mess ihm 106]..." -underline 0 -command "a_propos_asjob $w"
# aide contextuelle
   bind $mh <<MenuSelect>> "ShowStatus menu $mh asjob"
   pack $fm.help -side right
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Liste des boutons situs  droite
#
   pack [frame $w.suivi -relief raised -bd 1] -anchor w -expand no -fill x
   pack [frame $w.suivi.but_r] -side right -padx 5
   pack [frame $w.suivi.but_r.li] -side left -pady 10

   set m  $w.suivi.but_r.li.file.m
   menubutton $w.suivi.but_r.li.file -text "Editer" -font $but_fnt -menu $m -relief raised
   menu $m -tearoff 0
   $m add command -label "Fichier output" -underline 8 -font $but_fnt -command "editJobSel $w.suivi.ftx1.lbx output"
   $m add command -label "Fichier error"  -underline 8 -font $but_fnt -command "editJobSel $w.suivi.ftx1.lbx error"
   pack $w.suivi.but_r.li.file -pady 5 -fill x

   button $w.suivi.but_r.li.su -text "Supprimer " -font $but_fnt -command "suppr_job $w.suivi.ftx1.lbx"
   pack $w.suivi.but_r.li.su -pady 5 -fill x -expand yes

   button $w.suivi.but_r.li.ac -text "Actualiser " -font $but_fnt -command "loadStateJob $w.suivi.ftx1.lbx"
   pack $w.suivi.but_r.li.ac -pady 5 -fill x -expand yes

   pack [frame $w.suivi.but_r.cb] -side bottom -pady 18
   checkbutton $w.suivi.but_r.cb.bu -variable asjob::actu(indic) -command "reactu_jobs"
   pack $w.suivi.but_r.cb.bu -side left

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Listbox utilise pour afficher la liste des travaux
#
   frame $w.suivi.ftx1
   listbox $w.suivi.ftx1.lbx -xscrollcommand "$w.suivi.ftx1.scrollx set" -yscrollcommand "$w.suivi.ftx1.scrolly set" \
      -selectmode extended -height 10 -width 80 -font $lbx_fnt -bg white -setgrid true -listvar asjob::Jobs
   scrollbar $w.suivi.ftx1.scrolly -command "$w.suivi.ftx1.lbx yview"
   scrollbar $w.suivi.ftx1.scrollx -command "$w.suivi.ftx1.lbx xview" -orient h

   pack $w.suivi.ftx1.scrolly -side right  -fill y
   pack $w.suivi.ftx1.scrollx -side bottom -fill x
   pack $w.suivi.ftx1.lbx -in $w.suivi.ftx1 -expand yes -fill x
   pack $w.suivi.ftx1     -in $w.suivi      -expand yes -fill x
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Champ utilis pour la recherche d'expressions rgulires dans le fichier message
# Zone d'affichage du fichier message
   frame $w.ftx2
#
# Champ utilis pour la recherche d'expressions rgulires dans le fichier message
#
   frame  $w.ftx2.filtre
   label  $w.ftx2.filtre.label -text "Filtre :" -font $but_fnt -anchor w
   entry  $w.ftx2.filtre.entry -width 40 -textvariable expr_tail
   button $w.ftx2.filtre.button -text "Rechercher " -font $but_fnt -command "tailJobSel $w.suivi.ftx1.lbx"
   pack   $w.ftx2.filtre.label -side left
   pack   $w.ftx2.filtre.entry -side left -expand yes -fill x
   pack   $w.ftx2.filtre.button -side left -pady 5 -padx 10
   focus $w.ftx2.filtre.entry
   pack  $w.ftx2.filtre -expand no -fill x
#
# Zone de texte pour afficher le fichier message
#
   text $w.ftx2.lbx2 -xscrollcommand "$w.ftx2.scrollx set" -yscrollcommand "$w.ftx2.scrolly set" \
      -height $asjob::size(h,ftx2.lbx2) -width $asjob::size(w,ftx2.lbx2) -font $lbx_fnt -bg white
   scrollbar $w.ftx2.scrolly -command "$w.ftx2.lbx2 yview"
   scrollbar $w.ftx2.scrollx -command "$w.ftx2.lbx2 xview" -orient h
   pack $w.ftx2.scrolly -side right  -fill y
   pack $w.ftx2.scrollx -side bottom -fill x
   pack $w.ftx2.lbx2    -expand yes -fill both
   pack $w.ftx2         -expand yes -fill both -anchor w
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#  Affichage de la liste des jobs depuis le fichier stock sur le client
#
   if { [file exists $asjob::NomSuivi] } {
      lbxLoadFile $w.suivi.ftx1.lbx $asjob::NomSuivi
      $w.suivi.ftx1.lbx yview end
   }
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#  rcupration de la slection par double clic
#
   bind $w.suivi.ftx1.lbx <Double-Button-1> {
      set ficsel [selection get]
      set asjob::status "<INFO> Job [lindex $ficsel [lindex $asjob::paraJob(numero) 0]]"
      editJobSel %W output
   }
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#  rcupration de la slection par simple clic
#
   bind $w.suivi.ftx1.lbx <<ListboxSelect>> {
      set list_ [%W curselection]
      if {[llength $list_] == 1 } {
         set asjob::status "<INFO> Job [lindex [lindex $asjob::Jobs $list_] 0]"
      } else {
         set asjob::status ""
      }
   }
   update
   wm geometry $asjob::fen_root $asjob::size(root)
}
