#########################################################################
# COPYRIGHT (C) 2003         EDF R&D              WWW.CODE-ASTER.ORG    #
#                                                                       #
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR         #
# MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS        #
# PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE    #
# LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                       #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,       #
# BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF        #
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      #
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              #
#                                                                       #
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     #
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,       #
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.        #
#########################################################################

# $Id: fichier.tcl,v 1.48 2003/05/28 09:13:17 mcourtoi Exp $

# reaction a File/New
# aff!=OUI pour ne pas afficher d'onglet
#################################################################
proc nouveau {{ aff "OUI" }} {
   if { $astk::modprof } {
	   set ich [ tk_messageBox -message [ashare::mess ihm 132] -type yesnocancel -icon question ]
      if { $ich != "cancel" } {
         if { $ich == "yes" } {
            set iret [enregistrer $astk::profil(serv_profil) $astk::profil(nom_profil)]
            if { $iret != 0 } {
               return
            }
         }
      } else {
         return
      }
   }
   ashare::pointeur off
   affiche_onglet none
   array unset astk::profil *
   init_profil
   reinit_satellite
   set astk::profil(onglet_actif) $astk::ihm(ong,1,1)
   if { $aff == "OUI" } {
      affiche_onglet $astk::profil(onglet_actif)
   }
   ashare::pointeur on
}

# reaction a File/Open
#################################################################
proc ouvrir {srv fich} {
	if { $ashare::dbg } {
		ashare::log "<DEBUG> (ouvrir) Fichier profil : $srv $fich"
   }
   set iret 0
   if { $fich == "_VIDE" } {
      set iret [ashare::selecteur srv fich typ "" "" "F" "-initialfilt *.astk"]
   }
   if { $iret == 0 } {
      ashare::pointeur off
      set ftmp [file join $astk::tmpdir .file_open]
      set iret [ashare::rcp_cmd astk::config $srv $fich -1 $ftmp action .]
      if { $iret == 0 && [file exists $ftmp] } {
         nouveau NON
         set idop [open $ftmp r]
         while  { [eof $idop] != 1 } {
            gets $idop line
            if { [regexp {([^ ]*)[ ]+(.*)} $line mat1 mot1 mot2] == 1 } {
               if { $mot2 != "_VIDE" } {
                  set astk::profil($mot1) $mot2
                  if { $ashare::dbg > 1 } {
                     ashare::log "<DEBUG> (ouvrir) profil($mot1) = $mot2"
                  }
               } else {
                  set astk::profil($mot1) ""
               }
            }
         }
         close $idop
         file delete -force $ftmp
         set astk::profil(serv_profil) $srv
         set astk::profil(nom_profil) $fich
      # raffraichissement des derniers profils
         maj_prof $astk::profil(serv_profil) $astk::profil(nom_profil)
         modprof off
      # cohrence des serveurs du profil
         set iret [cohe_fich]
         if { $iret != 0 } {
            modprof on
            set astk::ihm(val_status) [ashare::mess ihm 96]
            tk_messageBox -message [ashare::mess ihm 96] -type ok -icon info
         }
      } else {
         set astk::ihm(val_status) [ashare::mess ihm 136]
         tk_messageBox -message [ashare::mess ihm 136] -type ok -icon info
      }
   # raffraichissement de l'ihm
      affiche_onglet $astk::profil(onglet_actif)
      verif_ongletM
      maj_sat
   # raffraichissement si agla
      raffr_ong_agla

      ashare::pointeur on
   }
}

# reaction a File/Save
#################################################################
proc enregistrer {srv fich} {
	if { $ashare::dbg } {
		ashare::log "<DEBUG> (enregistrer) Fichier profil : $srv $fich"
   }
   set iret 0
   if { $fich == "_VIDE" || $fich == [ashare::mess ihm 27] } {
      if { $fich != "_VIDE" } {
      # on n'est pas dans le cas Enregistrer sous...
         set ich [tk_messageBox -title [ashare::mess ihm 143] -message [ashare::mess ihm 132] -type yesno -icon question]
         if { $ich != "yes" } {
            return 1
         }
      }
      set iret [ashare::selecteur srv fich typ "" "" "F" "-initialfilt *.astk"]
   }
   if { $iret == 0} {
      set astk::ihm(val_status) [ashare::mess ihm 117]
      ashare::pointeur off
      # impose l'extension .astk (vrifie et ajoute si besoin)
      if { [regexp {\.astk$} $fich] != 1 } {
         append fich ".astk"
      }
      # ecrire le fichier
      set ftmp [file join $astk::tmpdir .file_save]
      set idsav [open $ftmp w]
      set ind [array get astk::profil]
      set n [expr [llength $ind] / 2]
      for {set i 0} {$i < $n} {incr i} {
         set k  [expr $i * 2]
         set k1 [expr $k + 1]
         set mot [lindex $ind $k]
         set val [lindex $ind $k1]
         if { [string length $val] == 0 } {
            set val "_VIDE"
         }
         puts $idsav "$mot $val"
         if { $ashare::dbg >= 2 } {
            ashare::log "<DEBUG> (enregistrer) profil($mot) = $val"
         }
      }
      close $idsav
      set iret [ashare::rcp_cmd astk::config -1 $ftmp $srv $fich action .]
      file delete -force $ftmp
      set astk::profil(serv_profil) $srv
      set astk::profil(nom_profil) $fich
# raffraichissement des derniers profils
      maj_prof $astk::profil(serv_profil) $astk::profil(nom_profil)
      ashare::pointeur on
      modprof off
   }
   if { $ashare::dbg } {
      ashare::log "<DEBUG> (enregistrer) iret=$iret ; srv # fich : $srv # $fich"
   }
   return $iret
}

# importer : reaction a File/Import
#   relit un profil cr par asterix 2.x ou fichier make_etude
#################################################################
proc importer { type } {
   switch -exact -- $type {
      asterix {
         set fil "*.pret *.prex"
      }
      astk_serv -
      run_aster -
      default {
         set fil "*"
         tk_messageBox -message [ashare::mess ihm 1] -type ok
         return
      }
   }
   set iret [ashare::selecteur srv fich typ "" "" "F" "-initialfilt \"$fil\""]
   if { $iret == 0 } {
      ashare::pointeur off
      nouveau NON
      set ftmp [file join $astk::tmpdir .file_import]
      set iret [ashare::rcp_cmd astk::config $srv $fich -1 $ftmp action .]
      if { $iret == 0 && [file exists $ftmp] } {
         set astk::profil(nom_profil) $fich
         set astk::profil(serv_profil) $srv
         set iret [import_$type $ftmp]
         file delete -force $ftmp
      }
   # raffraichissement de l'ihm
      affiche_onglet $astk::profil(onglet_actif)
      ashare::pointeur on
      modprof on
   }
	if { $ashare::dbg } {
      ashare::log "<DEBUG> (importer) retour : $iret"
   }
   if { $iret == 2 } {
      tk_messageBox -message [ashare::mess ihm 96] -type ok -icon info
   } elseif { $iret != 0 } {
      tk_messageBox -message [ashare::mess ihm 136] -type ok -icon info
   }
   return $iret
}

# exporter_sous : reaction a File/Export as
#################################################################
proc exporter_sous { type } {
   set iret [exporter $type -1 _VIDE]
   if { $iret == 2 } {
   # alarmes emises
      set astk::ihm(val_status) [ashare::mess ihm 96]
      tk_messageBox -message [ashare::mess ihm 96] -type ok -icon info
   } elseif { $iret != 0 } {
      tk_messageBox -message [ashare::mess ihm 136] -type ok -icon info
   }
   set astk::ihm(val_status) [ashare::mess ihm 12]
   update idletasks
}

# exporter : export d'un profil
#################################################################
proc exporter { type srv fich {verif "oui"}} {
	if { $ashare::dbg } {
		ashare::log "<DEBUG> (exporter) Fichier export : $srv $fich"
   }
   # extension par dfaut
   switch $type {
      run_aster { set ext run }
      astk_serv { set ext export }
      default   { set ext * }
   }
   # rcuprer les types (F)ichier ou (R)pertoire
   set iret 0
   if { $fich == "_VIDE" } {
      set iret [ashare::selecteur srv fich typ "" "" "F" "-initialfilt *.$ext"]
   }
   if { $iret == 0 } {
      ashare::pointeur off
      set jret 0
      if { $verif != "noverif" } {
         set jret [check_exist_type]
      }
      set astk::ihm(val_status) "[ashare::mess ihm 123]..."
      set ftmp [file join $astk::tmpdir .file_export]
      set iret [export_$type $ftmp]
      if { $iret != 4 } {
         set kret [ashare::rcp_cmd astk::config -1 $ftmp $srv $fich action .]
         file delete -force $ftmp
         if { $iret == 0 } {
            set iret $kret
         }
      }
      if { $iret == 0 } {
         set iret $jret
      }
      ashare::pointeur on
   }
	if { $ashare::dbg } {
      ashare::log "<DEBUG> (exporter) retour : $iret"
   }
   return $iret
}

#################################################################
proc quitter {} {
   if { $astk::modprof } {
	   set ich [ tk_messageBox -message [ashare::mess ihm 132] -type yesnocancel -icon question ]
      if { $ich != "cancel" } {
         if { $ich == "yes" } {
            # pour ne pas poser deux fois la question
            if { $astk::profil(nom_profil) == [ashare::mess ihm 27] } {
               set astk::profil(nom_profil) "_VIDE"
            }
            set iret [enregistrer $astk::profil(serv_profil) $astk::profil(nom_profil)]
            if { $iret != 0 } {
               return
            }
         }
      } else {
         return
      }
   } else {
	   set ich [ tk_messageBox -message [ashare::mess ihm 2] -type yesno -icon question ]
      if { $ich == "no" } {
         return
      }
   }
	ashare::my_exit 0
}

# export au format run_aster
#################################################################
proc export_run_aster { ftmp } {
   set ftmp2 "$ftmp.astk"
   set iret [export_astk_serv $ftmp2]
   if { $iret == 0 } {
      astk2run_aster::convert $astk::profil(version) $ftmp2 $ftmp
   }
   file delete -force $ftmp2
   # on complte avec les paramtres dpendant machine
   set id [open $ftmp a]
   puts $id "# les paramtres suivants dpendent de la machine de calcul"
   puts $id "# et de la version utilise"
   puts $id "plate-forme :"
   puts $id "rep_ref :"
   puts $id "rep_trav :"
   puts $id "rep_trav_local :"
   puts $id "# si pas de surcharge, il faut dfinir :"
   puts $id "exec :"
   puts $id "elco :"
   puts $id "rep_coco :"
   puts $id "# ventuellement, ajoutez dans para -rep_outils..."
   puts $id "para :"
   close $id
   return $iret
}

# verifier que les items en donnes existent et rcuprer leur type
# retourne : O si ok
#################################################################
proc check_exist_type { } {
   set iret 0
   # tabf : tableau temporaire qui contient les noms de fichiers par serveur
   # tabf(num_serv,nbfic)
   # tabf(num_serv,indice=1...nbfic) = etude 3 chemin_du_fichier
   for {set srv -1} {$srv < $astk::config(nb_serv)} {incr srv} {
      set tabf($srv,nbfic) 0
   }

   set astk::ihm(val_status) [ashare::mess ihm 244]
   # regroupe les fichiers par serveur
   foreach var { etude tests sources surcharge } {
      set var2 $var
      if { $var == "sources" } {
         # on ne "coche" par sources
         set var2 surcharge
      }
      if { $astk::profil($var2) == "oui" } {
         for {set i 0} { $i < $astk::profil($var,nbfic) } {incr i} {
            if { ( $var != "surcharge" && $astk::profil($var,fich,$i,donnee) )
              || ( $var == "surcharge" && $astk::profil($var,fich,$i,donnee)
                   && $astk::profil($var,fich,$i,resultat) == 0 ) } {
               # serveur
               set srv $astk::inv(serv,$astk::profil($var,fich,$i,serv))
	            # chemin du fichier
               set valf $astk::profil($var,fich,$i,nom)
               if { [string index $valf 0] != "/" } {
                  set valf [file join $astk::profil(path_$var) $valf]
               }
               # stocke le chemin
               incr tabf($srv,nbfic)
               set tabf($srv,$tabf($srv,nbfic)) [list $var $i $valf]
            } else {
               set typdef "X"
               for {set l 0} {$l < $astk::UL($var,nbre)} {incr l} {
                  if { $astk::profil($var,fich,$i,type) == $astk::UL($var,$l,nom) } {
                     set typdef $astk::UL($var,$l,FR)
                     break
                  }
               }
               # on met le type par dfaut
               set astk::profil($var,fich,$i,FR) $typdef
            }
         }
      }
   }
   # interrogation de chaque serveur
   set typdef "X"
   for {set srv -1} {$srv < $astk::config(nb_serv)} {incr srv} {
      if { $tabf($srv,nbfic) > 0 } {
         set cmd "/bin/sh -c \""
         for {set nf 1} {$nf <= $tabf($srv,nbfic)} {incr nf} {
            set vtab $tabf($srv,$nf)
            set var  [lindex $vtab 0]
            set i    [lindex $vtab 1]
            set valf [lindex $vtab 2]
#            append cmd "if test -f $valf ; then echo F ; else if test -d $valf ; then echo R ; else echo $typdef ; fi ; fi ; \\ \n"
            append cmd "if test -f $valf ; then echo F ; else if test -d $valf ; then echo R ; else echo $typdef ; fi ; fi ; "
         }
         append cmd "\""
         ashare::rexec_cmd $srv astk::config $cmd "" 0 out .
         set ltyp [split $out]
         set ntyp [llength $ltyp]
         if { $ntyp != $tabf($srv,nbfic) } {
            set iret 3
            ashare::mess erreur 3 check_exist_type $iret
         } else {
            for {set nf 1} {$nf <= $tabf($srv,nbfic)} {incr nf} {
               set vtab $tabf($srv,$nf)
               set valf [lindex $vtab 2]
               set typ  [lindex $ltyp [expr $nf - 1]]
               if { $ashare::dbg > 0 } {
                  ashare::log "<INFO> Type $typ : $valf"
               }
               set var  [lindex $vtab 0]
               set i    [lindex $vtab 1]
               set astk::profil($var,fich,$i,FR) $typ
               if { $typ == "X" } {
                  set msg [ashare::mess info 4 $valf]
                  set astk::ihm(val_status) $msg
                  tk_messageBox -message $msg -type ok -icon info
                  set iret 4
               }
            }
         }
      }
   }
   set astk::ihm(val_status) [ashare::mess ihm 12]
   return $iret
}

# import un profil au format asterix
#################################################################
proc import_asterix { fich } {
   set iret 0
   regsub {\.pret$} $astk::profil(nom_profil) ".astk" astk::profil(nom_profil)
   # compteurs de fichier etude, tests, source, surcharge
   set idp [open $fich r]
   while { [eof $idp] != 1 } {
      gets $idp line 
      if { [regexp {([^ ]*)[ ]+([^ ]*)[ ]+([^ ]*)[ ]+([^ ]*)[ ]+([^ ]*)[ ]+([^ ]*)[ ]+([^ ]*)[ ]+([^ ]*)} $line mat1 ctyp cfic clog csrv cul cD cR cC] } {
         set ist [is_type $ctyp]
         set var [lindex $ist 0]
         set ind [lindex $ist 1]
         if { $var == 0 } {
            ashare::log "<INFO> (import_asterix) On ne sait pas dans quelle liste mettre ce fichier :\n$ctyp ! $cfic ! $clog ! $csrv ! $cul ! $cD ! $cR ! $cC"
            set var etude
            set ctyp libr
            set iret 2
         }
         if { $ind != -1 } {
            if { $astk::UL($var,$ind,num) != $cul } {
               ashare::log "<INFO> (import_asterix) Type et UL ne correspondent pas pour ce fichier :\n$ctyp ! $cfic ! $clog ! $csrv ! $cul ! $cD ! $cR ! $cC"
               set ctyp libr
               set iret 2
            }
         }
         #set astk::profil(path_$var) [file dirname $astk::profil(nom_profil)]
         set i $astk::profil($var,nbfic)
         set srv $astk::local_server
         if { [regexp {\*} $csrv] == 0 } {
            for {set is 0} {$is < $astk::config(nb_serv)} {incr is} {
               if { [regexp -- $csrv $astk::config($is,nom_complet)] } {
                  set srv $astk::config($is,nom)
                  break
               }
            }
         }
         set astk::profil($var,fich,$i,nom) $cfic
         set astk::profil($var,fich,$i,serv) $srv
         set astk::profil($var,fich,$i,type) $ctyp
         set astk::profil($var,fich,$i,UL) $cul
         set astk::profil($var,fich,$i,donnee) $cD
         set astk::profil($var,fich,$i,resultat) $cR
         set astk::profil($var,fich,$i,compress) 0
         set astk::profil($var,fich,$i,FR) "F"
         incr astk::profil($var,nbfic)
      }
   }
   close $idp
   affiche_onglet etude
   return $iret
}

# dit si le type est dans etude, tests, sources ou surcharge... ou 0
#################################################################
proc is_type { typ } {
   set res 0
   set ind -1
   set ll { etude tests sources surcharge }
   set nl [llength $ll]
   for {set k 0} {$k < $nl} {incr k} {
      set var [lindex $ll $k]
      if { $res != 0 } {
         break
      } else {
         for {set i 0} {$i < $astk::UL($var,nbre)} {incr i} {
            if { $typ == $astk::UL($var,$i,nom) } {
               set res $var
               set ind $i
               break
            }
         }
      }
   }
   set lret [list $res $ind]
   return $lret
}
