#########################################################################
# COPYRIGHT (C) 2003         EDF R&D              WWW.CODE-ASTER.ORG    #
#                                                                       #
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR         #
# MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS        #
# PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE    #
# LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                       #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,       #
# BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF        #
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      #
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              #
#                                                                       #
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     #
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,       #
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.        #
#########################################################################

# $Id: i_serv.tcl,v 1.61 2003/06/17 08:24:06 mcourtoi Exp $

# Interface pour ASTK_SERV

# lancement en utilisant les services d'un serveur
# code retour : voir lance_calcul
#################################################################
proc lance_astk_serv { batch } {
   set iret 0
   set soumbtc 0
# indices ihm
   set serv $astk::inv(serv,$astk::profil(serveur))
# export du profil
   set astk::profil(special) ""
#
# exceptions AGLA
#
# exception pour asrest :
# - on regarde s'il y en a dj un
# - on demande confirmation ventuellement
   if { $astk::profil(agla) == "oui" && $astk::profil(asrest) == "oui"  } {
      set cmd "/bin/sh -c \"if test -d /aster/eda/"
      append cmd "$astk::profil(version)/$astk::config($serv,login)"
      append cmd "; then echo EXIST ; else echo RAS ; fi\""
      set astk::ihm(val_status) "[ashare::mess ihm 253]..."
      set iret [ashare::rexec_cmd $serv astk::config $cmd "" 0 out .]
      if { $iret == 0 } {
         if { [regexp EXIST $out] } {
            set msg [ashare::mess ihm 254 $astk::profil(version) $astk::config($serv,login)]
            set iret [tk_messageBox -message $msg -title [ashare::mess ihm 138] -type yesno -icon question -parent .]
            if { $iret != "yes" } {
               ashare::mess erreur 24
               return -999
            }
         }
      } else {
         # pb lancement de la commande
         ashare::mess "erreur" 3 $cmd $iret $out
         return $iret
      }
   }
# exception pour asdeno, on cree un profil bidon, on garde le bon dans sav_prof
   if { $astk::profil(agla) == "oui" && $astk::profil(asdeno) == "oui"  } {
      array set sav_prof [array get astk::profil]
      # on oublie les fichiers
      set astk::profil(etude,nbfic) 0
      set astk::profil(tests,nbfic) 0
      set astk::profil(sources,nbfic) 0
      set iret [asdeno_ihm]
      if { $iret != 0 } {
         array set astk::profil [array get sav_prof]
         ashare::mess erreur 24
         return -999
      }
      set iret [exporter astk_serv $astk::profil(serv_fich_export) $astk::profil(nom_fich_export) noverif]
   # on rtablit sav_prof ds qu'on n'en a plus besoin
      array set astk::profil [array get sav_prof]
      array unset sav_prof
   } else {
      set iret [exporter astk_serv $astk::profil(serv_fich_export) $astk::profil(nom_fich_export)]
   }
#
# retour export
   if { $iret == 2 } {
   # alarmes emises
      set astk::ihm(val_status) [ashare::mess ihm 96]
      tk_messageBox -message [ashare::mess ihm 96] -type ok -icon info
   } elseif { $iret == 4 } {
      # exit silencieux, les messages sont mis lors de l'export
      return -999
   } elseif { $iret == -888 } {
      set soumbtc $iret
   } elseif { $iret != 0 } {
      return $iret
   }

# prparation de la ligne de commande  excuter
   set lcmd ""
   set argu ""
   # as_exec fichier_export
   append lcmd [file join $astk::config($serv,rep_serv) as_serv]
   append lcmd " as_exec"
   if { [ashare::meme_machine $astk::config($serv,nom_complet) $astk::config($astk::profil(serv_fich_export),nom_complet)] != 1
     || $astk::config($serv,login) != $astk::config($astk::profil(serv_fich_export),login) } {
      append argu "$astk::config($astk::profil(serv_fich_export),login)@$astk::config($astk::profil(serv_fich_export),nom_complet):"
   }
   append argu $astk::profil(nom_fich_export)

   if { $ashare::dbg } {
      ashare::log "<DEBUG> (lance_astk_serv) $lcmd + $argu"
   }

# execution
   set astk::ihm(val_status) "[ashare::mess ihm 49]..."
   set iret [ ashare::rexec_cmd $serv astk::config $lcmd $argu 0 out .]
   set jret $iret
   if { $iret == 0 } {
      if { $soumbtc == 0 } {
      # traitement du retour
         set nomjob [get_nomjob]
         set jret [retour_as_exec $nomjob $out]
      } else {
         set jret $soumbtc
      }
   } else {
   # pb lancement de as_exec
      ashare::mess "erreur" 3 $lcmd $jret $out
      return $jret
   }
   if { $ashare::dbg } {
      ashare::log "<DEBUG> (lance_astk_serv) iret : $iret, output :\n$out"
      catch { ashare::log "<DEBUG> (lance_astk_serv) jobid=$jobid\nqueue=$queue" }
   }
   return $jret
}

# traitement du retour d'un as_exec
# nom du job et output
#################################################################
proc retour_as_exec { nomjob out } {
   set jret 0
# indices ihm
   set serv $astk::inv(serv,$astk::profil(serveur))
   # decodage du retour
   if { [regexp {JOBID[ ]*=[ ]*([0-9]+)} $out mat1 jobid] != 1 ||
        [regexp {QUEUE[ ]*=[ ]*([-a-z_A-Z0-9]+)} $out mat1 queue] != 1 } {
      set jret 3
   }
   if { $jret == 0} {
      if { $astk::profil(batch) } {
         set msg [ashare::mess ihm 125 $jobid $queue]
      } else {
         set msg [ashare::mess ihm 68 $jobid]
      }
      set astk::ihm(val_status) $msg
      update idletasks
   # prvenir asjob
      set date [clock format [clock seconds] -format "%d/%m/%y"]
      set heure [clock format [clock seconds] -format "%H:%M:%S"]
      set user $astk::config($serv,login)
      set nserv $astk::config($serv,nom_complet)
      set interf "ASTK_$astk::astk_version"
      if { $astk::profil(batch) } {
         set mode "batch"
      } else {
         set mode "interactif"
      }
      set kret [ajout_job $jobid $nomjob $date $heure PEND _ $queue _ $user $nserv $astk::profil(noeud) $interf $mode]
      if { $ashare::dbg } {
         ashare::log "<DEBUG> (retour_as_exec) call ajout_job, kret = $kret"
      }
      if { $kret != 0 } {
         set jret 6
         ashare::mess "erreur" 3 ajout_job $kret " "
      }
   }
   return $jret
}

# exporter pour astk_serv
# code retour : 2 = messages d'info mis ; 4 = erreur
#################################################################
proc export_astk_serv { ftmp } {
# UL non repetables qui existent dans plusieurs profils
   global ul_nrep flg
   array unset ul_nrep
   array unset flg

   set iret 0
# mise  zro des compteurs
   foreach var {etude tests sources surcharge} {
      for {set j 0} { $j < $astk::UL($var,nbre) } {incr j} {
         set flg($astk::UL($var,$j,nom)) ""
      }
   }
# indices ihm
   set serv $astk::inv(serv,$astk::profil(serveur))
   set idexp [open $ftmp w]
   set vers $astk::profil(version)
# paramtres
   puts $idexp "P serveur $astk::config($serv,nom_complet)"
   puts $idexp "P noeud $astk::profil(noeud)"
   puts $idexp "P username $astk::config($serv,login)"
   puts $idexp "P version $astk::profil(version)"
   puts $idexp "P ncpus $astk::profil(nb_proc)"
   if { $astk::profil(debug) } {
      puts $idexp "P debug debug"
	} else {
      puts $idexp "P debug nodebug"
	}
   if { $astk::profil(batch) } {
      puts $idexp "P mode batch"
	} else {
      puts $idexp "P mode interactif"
	}
   # nom du job
   set lign "P nomjob "
   append lign [get_nomjob]
   puts $idexp $lign
   puts $idexp "P origine ASTK $astk::astk_version"

# paramtre spcial
   if { $astk::profil(special) != "" } {
      puts $idexp "P special $astk::profil(special)"
   }

# arguments utilisateur
 	puts $idexp "A args $astk::profil(args)"

###########################
# mmoire et temps
# mmoire
   set tmp "A memjeveux "
	if { [ regexp {64$} $astk::config($serv,plate-forme) ] } {
	   append tmp [expr $astk::profil(memoire) / 8.]
	} else {
	   append tmp [expr $astk::profil(memoire) / 4.]
	}
   puts $idexp $tmp
# temps max (verif faite dans lance_calcul, si exporter direct...)
   set tmp "A tpmax "
   set vtps [ conv_tps $astk::profil(temps) ]
   append tmp $vtps
   puts $idexp $tmp
# mmoire et temps pour le batch et les infos
   set vmem [expr $astk::profil(memoire) * 1024]
   puts $idexp "P memjob $vmem"
   set vtmin [expr ( $vtps - 1 ) / 60 + 1]
   puts $idexp "P tpsjob $vtmin"
###########################
# Onglet surcharge coch
   set var surcharge
   if { $astk::profil($var) == "oui" } {
      # Liste des fichiers
      set jret [liste_astk_serv sources $idexp $vers]
      if { $jret != 0 } {
         set iret $jret
         if { $jret == 4 } {
            return $jret
         }
      }
      set jret [liste_astk_serv surcharge $idexp $vers]
      if { $jret != 0 } {
         set iret $jret
         if { $jret == 4 } {
            return $jret
         }
      }
   }
###########################
# Onglet Etude coch
   set var etude
   if { $astk::profil($var) == "oui" } {
 		if { $astk::profil(make_etude) == "oui" } {
 		   puts $idexp "P actions make_etude"
 		   if { $astk::profil(suivi_interactif) } {
		      set cmd $astk::config($serv,xterm)
            if { $cmd != "" } {
               if { [regexp -- {@D} $cmd] == 0 } {
                  append cmd " -display @D"
               }
               set cmd [ashare::subst_var $cmd]
               # retirer "-e ..."
               regsub -- {-e.*$} $cmd "" cmd
 		         puts $idexp "P xterm $cmd"
            } else {
               set msg [ashare::mess erreur 15 [ashare::mess ihm 83] $astk::profil(serveur)]
               tk_messageBox -message $msg -type ok -icon info
               set astk::ihm(val_status) $msg
            }
 		   }
		} else {
	# environnement pour debug
 		   puts $idexp "P actions make_env"
		}
	# Liste des fichiers
      set jret [liste_astk_serv $var $idexp $vers]
      if { $jret != 0 } {
         set iret $jret
         if { $jret == 4 } {
            return $jret
         }
      }
   }
	# fin onglet etude
###########################
# Bouton tests coch
   set var tests
   if { $astk::profil($var) == "oui" } {
      if { $astk::profil(agla) != "oui" } {
         puts $idexp "P actions astout"
# valeurs des options
         set npar [expr [llength $astk::ihm(l_par)] / 3]
         for {set i 0} {$i < $npar} {incr i} {
            set opt  [lindex $astk::ihm(l_par) [expr $i * 3]]
            puts $idexp "P $opt $astk::profil(opt_val,$opt)"
         }
      }
      # Liste des fichiers
      set jret [liste_astk_serv $var $idexp $vers]
      if { $jret != 0 } {
         set iret $jret
         if { $jret == 4 } {
            return $jret
         }
      }
   }
   # fin make_test
###########################
# Bouton agla coch
   set var agla
   if { $astk::profil($var) == "oui" } {
      for {set j 2} {$j <= $astk::ihm(nbong,$astk::ihm(nongl_agla)) } {incr j} {
         if { $astk::profil($astk::ihm(ong,$astk::ihm(nongl_agla),$j)) == "oui" } {
            puts $idexp "P actions $astk::ihm(ong,$astk::ihm(nongl_agla),$j)"
            break
         }
      }
   }
   # fin agla
###########################
# prsence d'un fichier btc en donne   seul => consbtc=non
#                           en resultat seul => soumbtc=non
   if { $flg(btc) != "" } {
      if { [regexp "D" $flg(btc)] } {
         puts $idexp "P soumbtc oui"
      } else {
         puts $idexp "P soumbtc non"
         set iret -888
      }
      if { [regexp "R" $flg(btc)] } {
         puts $idexp "P consbtc oui"
      } else {
         puts $idexp "P consbtc non"
      }
   } else {
      puts $idexp "P consbtc oui"
      puts $idexp "P soumbtc oui"
   }
# fin de l'export
   close $idexp
###########################
# Vrifications complmentaires
   # il devrait y avoir un .comm
   if { $astk::profil(etude) == "oui" && $flg(comm) == "" } {
      set msg [ashare::mess erreur 26]
      set iret 4
   }
   if { $astk::profil(surcharge) == "oui" && $astk::profil(agla) != "oui" } {
      # il faut un exec en rsultat s'il y a du C/fortran
      if { ($flg(f) != "" || $flg(c) != "") && [regexp "R" $flg(exec)] == 0 } {
         set msg [ashare::mess erreur 27]
         set iret 4
      }
      if { $astk::profil(etude) == "oui" 
        && (($flg(exec) != "" && [regexp "D" $flg(exec)] == 0)
         || ($flg(cmde) != "" && [regexp "D" $flg(cmde)] == 0)
         || ($flg(ele)  != "" && [regexp "D" $flg(ele) ] == 0)) } {
         set msg [ashare::mess erreur 30]
         set iret 4
      }
      # il faut un catalogue de commandes compil en rsultat s'il y a des capy
      if { $flg(capy) != "" && [regexp "R" $flg(cmde)] == 0 } {
         set msg [ashare::mess erreur 28]
         set iret 4
      }
      # il faut un catalogue d'lments compil en rsultat s'il y a des cata
      if { $flg(cata) != "" && [regexp "R" $flg(ele)] == 0 } {
         set msg [ashare::mess erreur 29]
         set iret 4
      }
   }
# message d'erreur
   if { $iret == 4 } {
      tk_messageBox -title [ashare::mess ihm 138] -message $msg -type ok -icon info
   }
#
   if { $ashare::dbg } {
      ashare::log "<DEBUG> (export_astk_serv) iret : $iret"
   }
   return $iret
}

# exporte le contenu d'une "liste_fich" pour run_aster
# types de liste : etude, tests, sources, surcharge
# code retour : 2 = messages d'info mis ; 4 = erreur
#################################################################
proc liste_astk_serv { var idexp vers } {
# UL non repetables qui existent dans plusieurs profils
   global ul_nrep flg

   set iret 0
# boucle sur les fichiers
 	for { set i 0 } { $i < $astk::profil($var,nbfic) } { incr i } {
      # flag tentative de rpter un fichier non rptable
      set ficrep 0
		# chemin du fichier
 	   set valf ""
 	   set sfic $astk::inv(serv,$astk::profil($var,fich,$i,serv))
 	   if { [ashare::meme_machine $astk::config($sfic,nom_complet) $astk::profil(noeud)] != 1
        || $astk::config($sfic,login) != $astk::config($astk::inv(serv,$astk::profil(serveur)),login) } {
 	   	append valf "$astk::config($sfic,login)@$astk::config($sfic,nom_complet):"
 	   }
 	   if { [string index $astk::profil($var,fich,$i,nom) 0] == "/" } {
 	      append valf "$astk::profil($var,fich,$i,nom)"
 	   } else {
 	      append valf [file join $astk::profil(path_$var) $astk::profil($var,fich,$i,nom)]
 	   }
   # enlever les /./
      regsub -all {/\./} $valf "/" valf
   # vrif du nom de fichier
      if { [regexp " " $valf mat1] } {
         ashare::mess info 24 $valf
         set iret 4
      }
   # vrif de l'UL
      regsub -all " " $astk::profil($var,fich,$i,UL) "" astk::profil($var,fich,$i,UL)
      regexp {([0-9]+)} $astk::profil($var,fich,$i,UL) mat1 val_ul
      if { $astk::profil($var,fich,$i,UL) != $val_ul || $val_ul > 99 } {
         ashare::mess info 25 $astk::profil($var,fich,$i,UL)
         set iret 4
      }
   # il faut tre en D ou R pour tre export
      if { $astk::profil($var,fich,$i,donnee) || $astk::profil($var,fich,$i,resultat) } {
      # flag
         set flag ""
         if { $astk::profil($var,fich,$i,donnee)   } { append flag "D" }
         if { $astk::profil($var,fich,$i,resultat) } { append flag "R" }
         if { $astk::profil($var,fich,$i,compress) } { append flag "C" }

         set typ $astk::profil($var,fich,$i,type)

         set lign $astk::profil($var,fich,$i,FR) 
         append lign " "
         append lign $typ
         append lign " "
         append lign $valf
         append lign " "
         append lign $flag
         append lign " "
         append lign $astk::profil($var,fich,$i,UL)
      # on regarde quel type on traite
         set flgold $flg($typ)
         for {set j 0} { $j < $astk::UL($var,nbre) } {incr j} {
            if { $typ == $astk::UL($var,$j,nom) } {
               append flg($typ) $flag
               set ityp $j
               break
            }
         }
      # vrifier que la compression est autorise
         if { $astk::profil($var,fich,$i,compress) && $astk::UL($var,$ityp,cpr) == 0 } {
            ashare::mess info 16 $typ
            set iret 4
         }
      # fichier non rptable (et commun  plusieurs profils)
         if { $astk::UL($var,$ityp,rep) < 0 } {
            # s'il existe, on prend sa valeur, sinon on gardera 0
            set ini 0
            catch { set ini $ul_nrep($typ) }
            set ul_nrep($typ) [expr $ini + 1]
            if { $ul_nrep($typ) == 1 } {
               puts $idexp $lign
            } else {
               set ficrep 1
            }
         } elseif { $astk::UL($var,$ityp,rep) == 2 } {
      # fichier rptable une fois en donne, une fois en rsultat maximum
            if { ([regexp D $flgold] && [regexp D $flag])
              || ([regexp R $flgold] && [regexp R $flag]) } {
               set ficrep 1
            } else {
               puts $idexp $lign
            }
         } elseif { $astk::UL($var,$ityp,rep) == 1 } {
      # fichier rptable
            puts $idexp $lign
         } elseif { $flgold == "" } {
      # premire occurence d'un fichier non rptable
            puts $idexp $lign
         } else {
            set ficrep 1
         }
      # on marque les actions  la premire occurence
         if { $var == "surcharge" && $flgold == ""
           && ( $typ == "exec" || $typ == "cmde" || $typ == "ele" )
           && $astk::profil(agla) != "oui"
           && $astk::profil($var,fich,$i,resultat) } {
            puts $idexp "P actions make_$typ"
         }
      }
   # message si tentative de rptition non permise
      if { $ficrep } {
         ashare::mess info 15 $typ $valf
         set iret 2
      }
 	}

# Code retour
   if { $ashare::dbg } {
      ashare::log "<DEBUG> (liste_astk_serv) (var=$var), iret : $iret"
   }
   return $iret
}

# retourne le nom du job : nom du profil ou fonction agla
#################################################################
proc get_nomjob { } {
   set nomjob "unknown"
   if { $astk::profil(agla) == "oui" } {
      for {set j 2} {$j <= $astk::ihm(nbong,$astk::ihm(nongl_agla)) } {incr j} {
         if { $astk::profil($astk::ihm(ong,$astk::ihm(nongl_agla),$j)) == "oui" } {
            set nomjob $astk::ihm(ong,$astk::ihm(nongl_agla),$j)
            append nomjob "_"
            append nomjob $astk::profil(version)
            break
         }
      }
   } elseif { $astk::profil(tests) == "oui" } {
      set nomjob astout
   } else {
      set nomjob [file rootname [file tail $astk::profil(nom_profil)]]
   }
   return $nomjob
}
