#########################################################################
# COPYRIGHT (C) 2003         EDF R&D              WWW.CODE-ASTER.ORG    #
#                                                                       #
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR         #
# MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS        #
# PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE    #
# LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                       #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,       #
# BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF        #
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      #
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              #
#                                                                       #
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     #
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,       #
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.        #
#########################################################################

# $Id: ihm_liste.tcl,v 1.37 2003/06/04 16:10:59 mcourtoi Exp $

# liste des fichiers ETUDE, TESTS, SOURCES, SURCHARGE
#################################################################
proc liste_fich {fenetre_parent pos_debut var} {
   set nombre $astk::profil($var,nbfic)
   init_sel
   
   if {$pos_debut == 0} {
      if { $var == "etude" } {
         set nb_lig 9
         set nb_col 6
      } elseif { $var == "tests" } {
         set nb_lig 9
         set nb_col 4
      } elseif { $var == "sources" } {
         set nb_lig 6
         set nb_col 3
      } elseif { $var == "surcharge" } {
         set nb_lig 6
         set nb_col 4
      }
      catch {unset table}
      array set table {
         rows    $nombre
         cols    $nb_col
         table   .table_$var
         array   tabfic
      }

      set $fenetre_parent.tabfic $table(table)
      destroy $fenetre_parent.tabfic
      destroy $fenetre_parent.sx
      destroy $fenetre_parent.sy
      table $fenetre_parent.tabfic -anchor n -rows [expr $table(rows) + 1] -cols [expr $table(cols) + 1] \
         -titlerows  1 -titlecols  0 \
         -roworigin -1 -colorigin 0 \
         -rowheight -20 \
         -borderwidth 2\
         -height $nb_lig\
         -variable $table(array) \
         -flashmode off \
         -cursor {} \
         -borderwidth 0 \
         -state normal \
         -xscrollcommand "$fenetre_parent.sx set" -yscrollcommand "$fenetre_parent.sy set"

      if { $var == "etude" } {
         $fenetre_parent.tabfic width 0 10 1 16 2 30 3 5 4 3 5 3 6 3
      } elseif { $var == "tests" } {
         $fenetre_parent.tabfic width 0 10 1 16 2 36 3 3 4 3 5 3
      } elseif { $var == "sources" } {
         $fenetre_parent.tabfic width 0 10 1 16 2 36 3 3 4 3
      } elseif { $var == "surcharge" } {
         $fenetre_parent.tabfic width 0 10 1 16 2 33 3 3 4 3 5 3
      }
      label $fenetre_parent.tabfic.t0 -font $astk::ihm(font,lab) -text [ashare::mess ihm 14]
      label $fenetre_parent.tabfic.t1 -font $astk::ihm(font,lab) -text [ashare::mess ihm 15]
      label $fenetre_parent.tabfic.t2 -font $astk::ihm(font,lab) -text [ashare::mess ihm 16]
      $fenetre_parent.tabfic window config -1,0 -window $fenetre_parent.tabfic.t0 
      $fenetre_parent.tabfic window config -1,1 -window $fenetre_parent.tabfic.t1 
      $fenetre_parent.tabfic window config -1,2 -window $fenetre_parent.tabfic.t2 
      if { $var == "etude" } {
         label $fenetre_parent.tabfic.t3 -font $astk::ihm(font,lab) -text [ashare::mess ihm 17]
         label $fenetre_parent.tabfic.t4 -font $astk::ihm(font,lab) -text [ashare::mess ihm 18]
         label $fenetre_parent.tabfic.t5 -font $astk::ihm(font,lab) -text [ashare::mess ihm 19]
         label $fenetre_parent.tabfic.t6 -font $astk::ihm(font,lab) -text [ashare::mess ihm 20]
         $fenetre_parent.tabfic window config -1,3 -window $fenetre_parent.tabfic.t3 
         $fenetre_parent.tabfic window config -1,4 -window $fenetre_parent.tabfic.t4 
         $fenetre_parent.tabfic window config -1,5 -window $fenetre_parent.tabfic.t5 
         $fenetre_parent.tabfic window config -1,6 -window $fenetre_parent.tabfic.t6 
      } elseif { $var == "tests" } {
         label $fenetre_parent.tabfic.t4 -font $astk::ihm(font,lab) -text [ashare::mess ihm 18]
         label $fenetre_parent.tabfic.t5 -font $astk::ihm(font,lab) -text [ashare::mess ihm 19]
         $fenetre_parent.tabfic window config -1,3 -window $fenetre_parent.tabfic.t4 
         $fenetre_parent.tabfic window config -1,5 -window $fenetre_parent.tabfic.t5 
      } elseif { $var == "sources" } {
         label $fenetre_parent.tabfic.t4 -font $astk::ihm(font,lab) -text [ashare::mess ihm 18]
         $fenetre_parent.tabfic window config -1,3 -window $fenetre_parent.tabfic.t4 
      } elseif { $var == "surcharge" } {
         label $fenetre_parent.tabfic.t4 -font $astk::ihm(font,lab) -text [ashare::mess ihm 18]
         label $fenetre_parent.tabfic.t5 -font $astk::ihm(font,lab) -text [ashare::mess ihm 19]
         $fenetre_parent.tabfic window config -1,3 -window $fenetre_parent.tabfic.t4 
         $fenetre_parent.tabfic window config -1,4 -window $fenetre_parent.tabfic.t5 
      }

      scrollbar $fenetre_parent.sx -orient h -command "$fenetre_parent.tabfic xview"
      scrollbar $fenetre_parent.sy -orient v -command "$fenetre_parent.tabfic yview"
      pack $fenetre_parent.tabfic $fenetre_parent.sy -side left -fill both -expand 1
   
   }
   for {set i $pos_debut} {$i < $nombre} {incr i 1} {
      entry $fenetre_parent.tabfic.ligne($i,nom) -width 40 -font $astk::ihm(font,val) -textvariable astk::profil($var,fich,$i,nom)
      $fenetre_parent.tabfic.ligne($i,nom) configure -validate key -vcmd {modprof}
      bind $fenetre_parent.tabfic.ligne($i,nom) <1>        { bind_1_nom %W }
      bind $fenetre_parent.tabfic.ligne($i,nom) <Double-1> { bind_dble_nom %W }
   	bind $fenetre_parent.tabfic.ligne($i,nom) <3>        { bind_3_nom %W %X %Y }

      if { $var == "etude" } {
         checkbutton $fenetre_parent.tabfic.ligne($i,donnee) -offvalue 0 -onvalue 1 \
            -variable astk::profil($var,fich,$i,donnee) -command {modprof}
         checkbutton $fenetre_parent.tabfic.ligne($i,resultat) -offvalue 0 -onvalue 1 \
               -variable astk::profil($var,fich,$i,resultat) -command {modprof}
         checkbutton $fenetre_parent.tabfic.ligne($i,compress) -offvalue 0 -onvalue 1 \
               -variable astk::profil($var,fich,$i,compress) -command {modprof}
         entry $fenetre_parent.tabfic.ligne($i,ul) -width 2 -justify right -font $astk::ihm(font,val) -textvariable astk::profil($var,fich,$i,UL)
         $fenetre_parent.tabfic.ligne($i,ul) configure -validate key -vcmd {modprof}
      } elseif { $var == "tests" } {
         checkbutton $fenetre_parent.tabfic.ligne($i,donnee) -offvalue 0 -onvalue 1 \
            -variable astk::profil($var,fich,$i,donnee) 
         checkbutton $fenetre_parent.tabfic.ligne($i,resultat) -offvalue 0 -onvalue 1 \
               -variable astk::profil($var,fich,$i,resultat) 
      } elseif { $var == "sources" } {
         checkbutton $fenetre_parent.tabfic.ligne($i,donnee) -offvalue 0 -onvalue 1 \
            -variable astk::profil($var,fich,$i,donnee) 
      } elseif { $var == "surcharge" } {
         checkbutton $fenetre_parent.tabfic.ligne($i,donnee) -offvalue 0 -onvalue 1 \
            -variable astk::profil($var,fich,$i,donnee) 
         checkbutton $fenetre_parent.tabfic.ligne($i,resultat) -offvalue 0 -onvalue 1 \
               -variable astk::profil($var,fich,$i,resultat) 
      }
      
      
      set m [tk_optionMenu $fenetre_parent.tabfic.ligne($i,type) astk::profil($var,fich,$i,type) $astk::UL($var,0,nom)]
      $m entryconfigure 0 -font $astk::ihm(font,lablst) -command "set astk::profil($var,fich,$i,UL) $astk::UL($var,0,num)"
      for {set j 1} {$j < $astk::UL($var,nbre)} {incr j} {
         $m add radiobutton
         $m entryconfigure $j -label $astk::UL($var,$j,nom) -font $astk::ihm(font,lablst) -command "set_UL $fenetre_parent $i $j $var ; modprof" -variable astk::profil($var,fich,$i,type)
      }
      $fenetre_parent.tabfic.ligne($i,type) configure -width 5 -font $astk::ihm(font,lablst)       
      [lindex [$fenetre_parent.tabfic.ligne($i,type) configure -menu] 4] configure -type
      $fenetre_parent.tabfic.ligne($i,type).menu configure
      
      set m2 [tk_optionMenu $fenetre_parent.tabfic.ligne($i,serv) astk::profil($var,fich,$i,serv) $astk::config(-1,nom)]
      $m2 entryconfigure 0 -font $astk::ihm(font,lablst)
      for {set j 0} {$j < $astk::config(nb_serv)} {incr j} {
         set j1 [expr $j + 1]
         $m2 add radiobutton
         $m2 entryconfigure $j1 -label $astk::config($j,nom) -font $astk::ihm(font,lablst) -variable astk::profil($var,fich,$i,serv) -command {modprof}
      }
      $fenetre_parent.tabfic.ligne($i,serv) configure -font $astk::ihm(font,lablst)
      [lindex [$fenetre_parent.tabfic.ligne($i,serv) configure -menu] 4] configure -type
      $fenetre_parent.tabfic.ligne($i,serv).menu configure

       
      $fenetre_parent.tabfic window config $i,0 -window $fenetre_parent.tabfic.ligne($i,type)
      $fenetre_parent.tabfic window config $i,1 -window $fenetre_parent.tabfic.ligne($i,serv)
      $fenetre_parent.tabfic window config $i,2 -window $fenetre_parent.tabfic.ligne($i,nom)
      if { $var == "etude" } {
         $fenetre_parent.tabfic window config $i,3 -window $fenetre_parent.tabfic.ligne($i,ul)
         $fenetre_parent.tabfic window config $i,4 -window $fenetre_parent.tabfic.ligne($i,donnee)
         $fenetre_parent.tabfic window config $i,5 -window $fenetre_parent.tabfic.ligne($i,resultat) 
         $fenetre_parent.tabfic window config $i,6 -window $fenetre_parent.tabfic.ligne($i,compress)
      } elseif { $var == "tests" } {
         $fenetre_parent.tabfic window config $i,3 -window $fenetre_parent.tabfic.ligne($i,donnee)
         $fenetre_parent.tabfic window config $i,5 -window $fenetre_parent.tabfic.ligne($i,resultat) 
      } elseif { $var == "sources" } {
         $fenetre_parent.tabfic window config $i,3 -window $fenetre_parent.tabfic.ligne($i,donnee)
      } elseif { $var == "surcharge" } {
         $fenetre_parent.tabfic window config $i,3 -window $fenetre_parent.tabfic.ligne($i,donnee)
         $fenetre_parent.tabfic window config $i,4 -window $fenetre_parent.tabfic.ligne($i,resultat) 
      }
   }
   pack configure $fenetre_parent.sy -fill y -expand 1
   pack configure $fenetre_parent.tabfic -fill y -expand 1
}

# event : clic sur nom de fichier
#################################################################
proc bind_1_nom { w } {
   set ch [liste_getsel $w]
   set var  [lindex $ch 0]
   set i    [lindex $ch 1]
   if { $ashare::dbg >= 3 } {
      ashare::log "<DEBUG> (bind_1_nom) sel(old,$var,$i) = [lindex $astk::sel(filename) 0]"
   }
}

# event : bouton droit sur un fichier => affiche le popup menu
#################################################################
proc bind_3_nom { w x y } {
   bind_1_nom $w
   tk_popup $astk::ihm(popup) $x $y
}

# event : double-clic sur nom de fichier
#################################################################
proc bind_dble_nom { w } {
   liste_getsel $w
   ashare::file_open typ
}

# chemin de base
# fenetre_liste : contient la liste des fichiers  raffraichir
# var : etude, tests...
#################################################################
proc chemin_base { fenetre_parent fenetre_liste var } {
   label $fenetre_parent.lbl -font $astk::ihm(font,lab) -text [ashare::mess ihm 21]
   entry $fenetre_parent.pth -width 40 -font $astk::ihm(font,val) -textvariable astk::profil(path_$var)
   $fenetre_parent.pth configure -validate key -vcmd {modprof}
   bind $fenetre_parent.pth <FocusIn> "add_chbase $var"
   bind $fenetre_parent.pth <FocusOut> "sub_chbase $var"

# bouton ouvrir le chemin de base
   button $fenetre_parent.ouvrir -image [image create photo -file $astk::icon(openR)] -command "ouvrir_chemin_base $var ; liste_fich $fenetre_liste 0 $var"
   pack $fenetre_parent.lbl -side left
   pack $fenetre_parent.pth -side left
   pack $fenetre_parent.ouvrir -side right
# bind
   set ashare::context($fenetre_parent.ouvrir,bouton) [ashare::mess ihm 195]
   bind $fenetre_parent.ouvrir <Enter>    {ShowStatus bouton %W astk}
   bind $fenetre_parent.ouvrir <FocusIn>  {ShowStatus bouton %W astk}
}

# ouvrir chemin de base
#################################################################
proc ouvrir_chemin_base { var } {
   add_chbase $var
   set iret [ashare::selecteur nserv dir type "" $astk::profil(path_$var) "R"]
   if { $iret == 0 } {
      set astk::profil(serv_$var) $nserv
      set astk::profil(path_$var) $dir
      sub_chbase $var
   }
}

# modif des fichiers
#################################################################
proc add_chbase { var } {
# on ajoute le chemin actuel aux noms de fichiers
   for {set i 0} {$i<$astk::profil($var,nbfic)} {incr i 1} {
      if { [string index $astk::profil($var,fich,$i,nom) 0] != "/" } {
         set astk::profil($var,fich,$i,nom) [file join $astk::profil(path_$var) $astk::profil($var,fich,$i,nom)]
      }
      regsub -all {/\./} $astk::profil($var,fich,$i,nom) "/" astk::profil($var,fich,$i,nom)
   }
# partage du mme chemin de base pour sources et surcharge
   if { $var == "sources" } {
      set astk::profil(path_surcharge) $astk::profil(path_$var)
      add_chbase surcharge
   }
}

# modif des fichiers
#################################################################
proc sub_chbase { var } {
   modprof
# retire l'ventuel /  la fin
   regsub "/$" $astk::profil(path_$var) "" astk::profil(path_$var)
# substitutions
   if { $astk::profil(path_$var) != "" } {
      for {set i 0} {$i<$astk::profil($var,nbfic)} {incr i 1} {
         set tmp $astk::profil($var,fich,$i,nom)
         regsub "^$astk::profil(path_$var)/" "$tmp" "./" astk::profil($var,fich,$i,nom)
      }
   }
# partage du mme chemin de base pour sources et surcharge
   if { $var == "sources" } {
      set astk::profil(path_surcharge) $astk::profil(path_$var)
      sub_chbase surcharge
   }
}

# icones pour une liste
#################################################################
proc liste_icone { fenetre_icone fenetre_liste var } {
# bouton nouveau
   button $fenetre_icone.nouveau -image [image create photo -file $astk::icon(new)] -command "nouv_act $fenetre_liste $var"
   pack $fenetre_icone.nouveau -pady 3 -padx 3
   set ashare::context($fenetre_icone.nouveau,bouton) [ashare::mess ihm 109]
# bouton ouvrir
   button $fenetre_icone.ouvrir -image [image create photo -file $astk::icon(openF)] -command "parcourir_act $fenetre_liste $var"
   pack $fenetre_icone.ouvrir -pady 3 -padx 3
   set ashare::context($fenetre_icone.ouvrir,bouton) [ashare::mess ihm 192]
# bouton detruire
   button $fenetre_icone.detruire -image [image create photo -file $astk::icon(delete)] -command "detr_act $fenetre_liste"
   pack $fenetre_icone.detruire -pady 3 -padx 3
   set ashare::context($fenetre_icone.detruire,bouton) [ashare::mess ihm 193]
# bouton editer
   button $fenetre_icone.editer -image [image create photo -file $astk::icon(edit)] -command "ashare::file_open edit"
   pack $fenetre_icone.editer -pady 3 -padx 3
   set ashare::context($fenetre_icone.editer,bouton) [ashare::mess ihm 194]
# bind
   foreach but {nouveau ouvrir detruire editer} {
      bind $fenetre_icone.$but <Enter>    {ShowStatus bouton %W astk}
      bind $fenetre_icone.$but <FocusIn>  {ShowStatus bouton %W astk}
      bind $fenetre_icone.$but <Leave>    {set astk::ihm(val_status) ""; update idletasks}
      bind $fenetre_icone.$but <FocusOut> {set astk::ihm(val_status) ""; update idletasks}
   }
}

# action nouveau
#################################################################
proc nouv_act { fenetre_liste var } {
   modprof
   set i $astk::profil($var,nbfic)
   if { $ashare::dbg >= 3 } {
      ashare::log "<DEBUG> (nouv_act) $fenetre_liste $var => astk::profil($var,fich,$i,XXX)"
   }
   set astk::profil($var,fich,$i,nom) ""
	set astk::profil($var,fich,$i,serv) $astk::config($astk::profil(serv_$var),nom)
   set astk::profil($var,fich,$i,type) $astk::UL($var,0,nom)
   set astk::profil($var,fich,$i,FR) "F"
   incr astk::profil($var,nbfic)
   $fenetre_liste.tabfic configure -rows [expr $astk::profil($var,nbfic) + 1]
   pack configure $fenetre_liste.sy -fill y -expand 1
   liste_fich $fenetre_liste [expr $astk::profil($var,nbfic) - 1] $var
   set_UL $fenetre_liste $i 0 $var
}

# action ouvrir
#################################################################
proc parcourir_act { fenetre_liste var } {
   modprof
   set iret [ashare::selecteur nserv nfich type "" $astk::profil(path_$var) "FR"]

   if { $iret == 0 } {
   	set astk::profil($var,fich,$astk::profil($var,nbfic),serv) $astk::config($nserv,nom)
      set astk::profil($var,fich,$astk::profil($var,nbfic),FR) $type
      if { $ashare::dbg >= 3 } {
			ashare::log "<DEBUG> (parcourir_act) selection : $nfich sur $nserv de type $type"
      }
   # substitutions du chemin de base
      if { $astk::profil(path_$var) != "" } {
         regsub "^$astk::profil(path_$var)/" $nfich "./" nfich
      }
      set astk::profil($var,fich,$astk::profil($var,nbfic),nom) $nfich
   	# determine l'extension du fichier
      set ext [file extension $nfich]

      set astk::profil($var,fich,$astk::profil($var,nbfic),donnee) 0
      set astk::profil($var,fich,$astk::profil($var,nbfic),resultat) 0
      set astk::profil($var,fich,$astk::profil($var,nbfic),compress) 0

   	# positionner le type et l'UL en fonction de l'extension
   	# par defaut, on met le premier type
      set_UL $fenetre_liste $astk::profil($var,nbfic) 0 $var
      set astk::profil($var,fich,$astk::profil($var,nbfic),type) $astk::UL($var,0,nom)
      set astk::profil($var,fich,$astk::profil($var,nbfic),UL) $astk::UL($var,0,num)
   	for { set ic 0 } { $ic < $astk::UL($var,nbre) } { incr ic } {
         if { $ext == ".$astk::UL($var,$ic,nom)" } {
            set astk::profil($var,fich,$astk::profil($var,nbfic),type) $astk::UL($var,$ic,nom)
            set_UL $fenetre_liste $astk::profil($var,nbfic) $ic $var
         }
   	}
      incr astk::profil($var,nbfic)
      $fenetre_liste.tabfic configure -rows [expr $astk::profil($var,nbfic) + 1]
      pack configure $fenetre_liste.sy -fill y -expand 1
      liste_fich $fenetre_liste [expr $astk::profil($var,nbfic) - 1] $var
   }
}

# action detruire
#################################################################
proc detr_act { fenetre_liste } {
   set var $astk::sel(liste)
   set i   $astk::sel(indice)
   if { $var != "" && $i != "" } {
      modprof
      set serv $astk::inv(serv,$astk::sel(servname))
      incr astk::profil($var,nbfic) -1
      for {set j $i} {$j < $astk::profil($var,nbfic)} {incr j 1} {
         set j1 [expr $j + 1]
         set astk::profil($var,fich,$j,nom)      $astk::profil($var,fich,$j1,nom)
         set astk::profil($var,fich,$j,serv)     $astk::profil($var,fich,$j1,serv)
         set astk::profil($var,fich,$j,type)     $astk::profil($var,fich,$j1,type)
         set astk::profil($var,fich,$j,UL)       $astk::profil($var,fich,$j1,UL)
         set astk::profil($var,fich,$j,donnee)   $astk::profil($var,fich,$j1,donnee)
         set astk::profil($var,fich,$j,resultat) $astk::profil($var,fich,$j1,resultat)
         set astk::profil($var,fich,$j,compress) $astk::profil($var,fich,$j1,compress)
         set astk::profil($var,fich,$j,FR)       $astk::profil($var,fich,$j1,FR)
      }
      for {set j $i} {$j < [expr $astk::profil($var,nbfic) + 1]} {incr j} {
         destroy $fenetre_liste.tabfic.ligne($j,nom)
         destroy $fenetre_liste.tabfic.ligne($j,serv)
         destroy $fenetre_liste.tabfic.ligne($j,type)
         if { $var == "etude" } {
            destroy $fenetre_liste.tabfic.ligne($j,ul)
            destroy $fenetre_liste.tabfic.ligne($j,donnee)
            destroy $fenetre_liste.tabfic.ligne($j,resultat)
            destroy $fenetre_liste.tabfic.ligne($j,compress)
         } elseif { $var == "tests" } {
            destroy $fenetre_liste.tabfic.ligne($j,donnee)
            destroy $fenetre_liste.tabfic.ligne($j,resultat)
         } elseif { $var == "sources" } {
            destroy $fenetre_liste.tabfic.ligne($j,donnee)
         } elseif { $var == "surcharge" } {
            destroy $fenetre_liste.tabfic.ligne($j,donnee)
            destroy $fenetre_liste.tabfic.ligne($j,resultat)
         }
      }
      $fenetre_liste.tabfic configure -rows [expr $astk::profil($var,nbfic) + 1]
		unset astk::profil($var,fich,$astk::profil($var,nbfic),nom)
		unset astk::profil($var,fich,$astk::profil($var,nbfic),serv)
		unset astk::profil($var,fich,$astk::profil($var,nbfic),type)
		unset astk::profil($var,fich,$astk::profil($var,nbfic),UL)
		unset astk::profil($var,fich,$astk::profil($var,nbfic),donnee)
		unset astk::profil($var,fich,$astk::profil($var,nbfic),resultat)
		unset astk::profil($var,fich,$astk::profil($var,nbfic),compress)
		unset astk::profil($var,fich,$astk::profil($var,nbfic),FR)
      liste_fich $fenetre_liste $i $var
	} else {
      set msg [ashare::mess ihm 25]
      tk_messageBox -title [ashare::mess ihm 138] -message $msg -type ok -icon info
      set astk::ihm(val_status) $msg
   }
}

# affecte le numero de l'UL et flag par defaut
#################################################################
proc set_UL { fenetre_liste nli choix var } {
   set astk::profil($var,fich,$nli,UL) $astk::UL($var,$choix,num)
# on positionne les flags DRC selon le type
   if { [regexp D+ $astk::UL($var,$choix,def)] == 1 } {
      set astk::profil($var,fich,$nli,donnee) 1
   } else {
      set astk::profil($var,fich,$nli,donnee) 0
   }
   if { [regexp R+ $astk::UL($var,$choix,def)] == 1 } {
      set astk::profil($var,fich,$nli,resultat) 1
   } else {
      set astk::profil($var,fich,$nli,resultat) 0
   }
   if { [regexp C+ $astk::UL($var,$choix,def)] == 1 } {
      set astk::profil($var,fich,$nli,compress) 1
   } else {
      set astk::profil($var,fich,$nli,compress) 0
   }
}

# insert un nom par dfaut en fonction du type choisi
#################################################################
proc valeur_defaut { } {
   set var $astk::sel(liste)
   set i   $astk::sel(indice)
   if { $astk::profil(nom_profil) == [ashare::mess ihm 27] } {
      return
   }
   regsub {\.astk$} $astk::profil(nom_profil) ".$astk::profil($var,fich,$i,type)" def
   if { $astk::profil(path_$var) != "" } {
      regsub "^$astk::profil(path_$var)/" "$def" "./" def
   }
   set astk::profil($var,fich,$i,nom) $def
}

# construit le popup menu
#################################################################
proc create_popup { m } {
   menu $m -tearoff 0 -bd 1
   $m add command -label [ashare::mess ihm 169] -font $astk::ihm(font,labmenuB) -command {ashare::file_open typ}
   $m add command -label [ashare::mess ihm 171] -font $astk::ihm(font,labmenu)  -command {ashare::file_open edit}
   $m add command -label [ashare::mess ihm 179] -font $astk::ihm(font,labmenu)  -command {ashare::file_print_to}
   $m add separator
   $m add cascade -menu $m.opw -label [ashare::mess ihm 170] -font $astk::ihm(font,labmenu) -state disabled
   $m add separator
   $m add command -label [ashare::mess ihm 252] -font $astk::ihm(font,labmenu)  -command {valeur_defaut}
   $m add separator
   $m add command -label [ashare::mess ihm 172] -font $astk::ihm(font,labmenu)  -command {ashare::file_prop}
}

# complte le popup menu
#################################################################
proc complete_popup { pop } {
   set mopw $pop.opw
   catch { destroy $mopw }
   menu $mopw -tearoff 0 -bd 1
# tableau inverse
   for {set j 0} {$j < $astk::outils(nb)} {incr j} {
      set astk::inv(outil,$astk::outils($j,nom)) $j
      if { $ashare::dbg >= 3 } {
         ashare::log "<DEBUG> (liste_outils) inv(outil,$astk::outils($j,nom)) = $j"
      }
   }
# outils standard
   set nb [expr [llength $astk::ihm(outils)] / 2]
   set nn 0
   for {set i 0} {$i < $nb} {incr i} {
      set out  [lindex $astk::ihm(outils) [expr $i * 2]]
      set ctxt [lindex $astk::ihm(outils) [expr $i * 2 + 1]]
      set test -1
      catch {set test $astk::inv(outil,$out)}
      # si l'outil n'est pas configur : disabled
      set etat "disabled"
      if { $test >= 0 || [lsearch $astk::ihm(outils_autocfg) $out] > -1 } {
         set etat "normal"
         incr nn
#MC ne pas donner accs tant que  ne marche pas perfecto !
         if { [lsearch $astk::ihm(outils_autocfg) $out] > -1 } {
            set etat "disabled"
         }
      }
      $mopw add command -font $astk::ihm(font,labmenu) -label $out \
         -command "run_tool $out" -state $etat
   }
# outils perso
   # combien ?
   set nbp [expr $astk::outils(nb) - $nn + [llength $astk::ihm(outils_autocfg)]]
   if { $nbp > 0 } {
      $mopw add separator
      for {set j 0} {$j < $astk::outils(nb)} {incr j} {
         if { [lsearch $astk::ihm(outils) $astk::outils($j,nom)] == -1} {
            $mopw add command -font $astk::ihm(font,labmenu) -label $astk::outils($j,nom) \
               -command "run_tool $astk::outils($j,nom)"
         }
      }
   }
   if { $nb > 0 || $nbp > 0 } {
      $pop entryconfigure [ashare::mess ihm 170] -state normal
   } else {
      $pop entryconfigure [ashare::mess ihm 170] -state disabled
   }
}

# recupere le nom du fichier et son serveur selectionns
#################################################################
proc liste_getsel { w {set "yes"} } {
   set txtvar [$w cget -textvariable]
   regexp {astk::profil\((.*),(.*),(.*),(.*)\)} $txtvar mat1 var fich ind  mc
   set tmp $astk::profil($var,fich,$ind,$mc)
   if { [string index $tmp 0] != "/" } {
      set tmp [file join $astk::profil(path_$var) $tmp]
   }
   regsub -all {/\./} $tmp "/" tmp
   set serv $astk::profil($var,fich,$ind,serv)
   if { $set == "yes" } {
      set astk::sel(liste) $var
      set astk::sel(indice) $ind
      set astk::sel(filename) [list $tmp]
      set astk::sel(servname) $serv
   }
   if { $ashare::dbg >= 3 } {
      ashare::log "<DEBUG> (liste_getsel) $astk::sel(liste) $astk::sel(indice) $astk::sel(filename) $astk::sel(servname)"
   }
   list lret
   lappend lret $var
   lappend lret $ind
   lappend lret $tmp
   lappend lret $serv
   return $lret
}
