#########################################################################
# COPYRIGHT (C) 2003         EDF R&D              WWW.CODE-ASTER.ORG    #
#                                                                       #
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR         #
# MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS        #
# PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE    #
# LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                       #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,       #
# BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF        #
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      #
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              #
#                                                                       #
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     #
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,       #
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.        #
#########################################################################

# $Id: ihm_main.tcl,v 1.21 2003/05/26 12:04:37 mcourtoi Exp $

# construction de la fenetre principale de l'interface
#################################################################
proc astk_princ { { REINI "INI" } } {
# message de mise  jour
   set client_vers "00.00.00"
   if { [regexp {([0-9]+)\.([0-9]+)\.([0-9]+)} $astk::astk_version mat1 i1 i2 i3] } {
      set client_vers [format "%02d.%02d.%02d" $i1 $i2 $i3]
   }
   if { $astk::config(-1,flag_maj) != $client_vers } {
      tk_messageBox -title [ashare::mess ihm 138] -message [ashare::mess ihm 242] -type ok -icon info
      set astk::config(-1,flag_maj) $client_vers
      ashare::save_prefs
   }

# fenetre principale
   ashare::pointeur off

	# Titre de la fenetre + menu + creation de la frame complete
	set_titre
	# on fixe la taille de la fenetre
	wm resizable . 0 0
   wm protocol . WM_DELETE_WINDOW { quitter }
	pack [frame $astk::ihm(menu) -relief raised -bd 1] -fill x -side top -anchor nw
	pack [frame .fen -relief raised -bd 0] -fill both -expand 1 -anchor nw
	   pack [frame $astk::ihm(fenetre) -relief raised -bd 1] -side left -fill both -expand 1 -anchor nw
	   pack [frame $astk::ihm(satellite) -relief raised -bd 1] -fill y -expand 1 -anchor nw
	pack [frame $astk::ihm(status) -relief raised -bd 0] -fill x -anchor s -expand 1

	# barre de menu
   create_popup $astk::ihm(popup)
	create_menu $astk::ihm(menu) $astk::ihm(fenetre).active

	# frame "satellite"
	affiche_satellite

   # etat, aide...
   affiche_status

	# il est ncessaire d'afficher l'onglet en dernier car c'est lui qui bride
	# la taille de la fenetre
	pack [frame $astk::ihm(fenetre).onglet] -anchor w
	# creation et initialisation des onglets
	init_onglet

	# lecture du profil initial
	if { $astk::ihm(profil_ini) != "" } {
		ouvrir $astk::ihm(serv_ini) $astk::ihm(profil_ini)
      set astk::ihm(profil_ini) ""
	} else {
	   # pour le demarrage
	   affiche_onglet $astk::profil(onglet_actif)
	}

   # cree la liste des noeuds, des versions, choix batch/interactif...
   maj_sat

   # fenetre init
   catch {destroy .fen_about}
   
   # affichage
   ashare::pointeur on
   wm deiconify .
   update idletasks
}

# raffraichir la fenetre principale de l'interface
#################################################################
proc raffr_princ { } {
   global ongsel
# sous-onglets slectionns
   for {set i 1} {$i <= $astk::ihm(nbongM)} {incr i} {
      for {set j 1} {$j <= $astk::ihm(nbong,$i)} {incr j} {
         if { $ongsel($i) == $astk::ihm(tit,$i,$j) } {
            set ongsel($i) $j
         }
      }
   }
# rinitialisation du nom des onglets
   def_onglet
   for {set i 1} {$i <= $astk::ihm(nbongM)} {incr i} {
      set ongsel($i) $astk::ihm(tit,$i,$ongsel($i))
   }
# dtruit les fentres filles et ouvre de nouveau asjob s'il existait
   set iasj [winfo exists $astk::ihm(asjob)]
   eval destroy [winfo children .]
# raffichage
   astk_princ DETR
   if { $iasj } {
      show_fen $astk::ihm(asjob)
   }
   raise .
}

