#########################################################################
# COPYRIGHT (C) 2003         EDF R&D              WWW.CODE-ASTER.ORG    #
#                                                                       #
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR         #
# MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS        #
# PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE    #
# LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                       #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,       #
# BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF        #
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      #
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              #
#                                                                       #
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     #
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,       #
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.        #
#########################################################################

# $Id: ihm_satellite.tcl,v 1.18 2003/05/26 12:04:37 mcourtoi Exp $

#################################################################
proc reinit_satellite { } {
   # paramtres stocks pour le passage satellite normal (0)  AGLA (1)
   set astk::ihm(old,sat,0,noeud) "non_AGLA"
   set astk::ihm(old,sat,0,memoire) 32
   set astk::ihm(old,sat,0,temps) 60
   set astk::ihm(old,sat,1,noeud) "AGLA"
   set astk::ihm(old,sat,1,memoire) 128
   set astk::ihm(old,sat,1,temps) 05:00
   maj_sat
   adapt_satellite 0
}

#################################################################
proc affiche_satellite { } {
	# frame subtit : memoire, temps, machine, version...
	pack [frame $astk::ihm(satellite).subtit -relief raised -bd 1 ] -pady 3 -padx 3 -fill both
      # memoire
	   pack [frame $astk::ihm(satellite).subtit.memoire -relief solid -bd 0] -fill x -anchor w
	      pack [label $astk::ihm(satellite).subtit.memoire.lbl -font $astk::ihm(font,lab) -text [ashare::mess ihm 42]] -side left
	      pack [entry $astk::ihm(satellite).subtit.memoire.mem -width 6  -justify right -font $astk::ihm(font,val) -textvariable astk::profil(memoire)] -anchor e
         $astk::ihm(satellite).subtit.memoire.mem configure -validate key -vcmd modprof

      # temps
	   pack [frame $astk::ihm(satellite).subtit.temps -relief solid -bd 0] -fill x -anchor w
	      pack [label $astk::ihm(satellite).subtit.temps.lbl -font $astk::ihm(font,lab) -text [ashare::mess ihm 43]] -side left
	      pack [entry $astk::ihm(satellite).subtit.temps.tps -width 6  -justify right -font $astk::ihm(font,val) -textvariable astk::profil(temps)]  -anchor e
         $astk::ihm(satellite).subtit.temps.tps configure -validate key -vcmd modprof

      # nbre processeurs
		set astk::profil(nb_proc) 1
	   pack [frame $astk::ihm(satellite).subtit.nb_proc -relief solid -bd 0] -fill x -anchor w
	      pack [label $astk::ihm(satellite).subtit.nb_proc.lbl -font $astk::ihm(font,lab) -text [ashare::mess ihm 44]] -side left
	      pack [entry $astk::ihm(satellite).subtit.nb_proc.nbp -width 6  -justify right -font $astk::ihm(font,val) -textvariable astk::profil(nb_proc)]  -anchor e
         $astk::ihm(satellite).subtit.nb_proc.nbp configure -validate key -vcmd modprof

      # machine
	   pack [frame $astk::ihm(satellite).subtit.machine -relief solid -bd 0] -fill x -anchor w
	      pack [label $astk::ihm(satellite).subtit.machine.lbl -font $astk::ihm(font,lab) -text [ashare::mess ihm 45]] -side left -anchor e
	      liste_machines $astk::ihm(satellite).subtit.machine

      # version
	   pack [frame $astk::ihm(satellite).subtit.version -relief solid -bd 0] -fill x -anchor w
	      pack [label $astk::ihm(satellite).subtit.version.lbl -font $astk::ihm(font,lab) -text [ashare::mess ihm 46]] -side left -anchor e

      # batch / interactif
	   pack [frame $astk::ihm(satellite).subtit.batch -relief solid -bd 0] -fill x -anchor w
	   radiobutton $astk::ihm(satellite).subtit.batch.batch -font $astk::ihm(font,lab) -text [ashare::mess ihm 51] -value 1 -variable astk::profil(batch) -command mod_batch
	   radiobutton $astk::ihm(satellite).subtit.batch.inter -font $astk::ihm(font,lab) -text [ashare::mess ihm 52] -value 0 -variable astk::profil(batch) -command mod_batch
	   pack $astk::ihm(satellite).subtit.batch.batch $astk::ihm(satellite).subtit.batch.inter -anchor w -padx 10 -pady 1

      # suivi
	   pack [frame $astk::ihm(satellite).subtit.suivi -relief solid -bd 0]
	   checkbutton $astk::ihm(satellite).subtit.suivi.choix -offvalue 0 -onvalue 1 -variable astk::profil(suivi_interactif)
	   label $astk::ihm(satellite).subtit.suivi.lbl -font $astk::ihm(font,lab) -text [ashare::mess ihm 47]
      pack $astk::ihm(satellite).subtit.suivi.choix $astk::ihm(satellite).subtit.suivi.lbl -side left
	         
	# frame debug / nodebug
	pack [frame $astk::ihm(satellite).debug -relief raised -bd 1 ] -pady 3 -padx 3 -fill both
	radiobutton $astk::ihm(satellite).debug.nodebug -font $astk::ihm(font,lab) -text nodebug -value 0 -variable astk::profil(debug)
	radiobutton $astk::ihm(satellite).debug.debug -font $astk::ihm(font,lab) -text debug -value 1 -variable astk::profil(debug)
	pack $astk::ihm(satellite).debug.nodebug $astk::ihm(satellite).debug.debug -anchor w -padx 10 -pady 1

	# frame bas : GO / EXIT
	pack [frame $astk::ihm(satellite).bas -relief raised -bd 1] -pady 3 -padx 3 -fill both -expand yes
		pack [frame $astk::ihm(satellite).bas.boutons1 -bd 0] -pady 5 -padx 5 -fill x -expand yes
		pack [frame $astk::ihm(satellite).bas.boutons2 -bd 0] -pady 5 -padx 5 -fill x -expand yes
	# bouton GO
	button $astk::ihm(satellite).bas.boutons1.go -font $astk::ihm(font,labbout) -text [ashare::mess ihm 189] -command { set astk::ihm(val_status) "[ashare::mess ihm 49]..." ; go_calcul } -background $astk::ihm(couleur,go) -activebackground $astk::ihm(couleur,go)
# bouton suivi des jobs
	button $astk::ihm(satellite).bas.boutons2.bjobs -font $astk::ihm(font,labbout) -text [ashare::mess ihm 48] \
		-background $astk::ihm(couleur,bout_off) -activebackground $astk::ihm(couleur,bout_off) \
		-command "show_fen $astk::ihm(asjob)"
	
	pack $astk::ihm(satellite).bas.boutons1.go    -padx 20 -pady 5 -fill x -expand yes
	pack $astk::ihm(satellite).bas.boutons2.bjobs -padx 20 -pady 5 -fill x -expand yes

   reinit_satellite
   # la modif des valeurs dans les entry produit un modprof (on)
   modprof off
}

# modif batch
#################################################################
proc mod_batch { } {
   set serv $astk::inv(serv,$astk::profil(serveur))
   if { $ashare::dbg >= 2 } {
      ashare::log "<DEBUG> (mod_batch) IN  : $astk::profil(batch)"
   }
   # possibilits du noeud
   if { $astk::config($serv,batch) == "oui" } {
      $astk::ihm(satellite).subtit.batch.batch configure -state normal
   } else {
      $astk::ihm(satellite).subtit.batch.batch configure -state disabled
   }
   if { $astk::config($serv,interactif) == "oui" } {
      $astk::ihm(satellite).subtit.batch.inter configure -state normal
      $astk::ihm(satellite).subtit.suivi.choix configure -state normal
      $astk::ihm(satellite).subtit.suivi.lbl configure -state normal
   } else {
      $astk::ihm(satellite).subtit.batch.inter configure -state disabled
      $astk::ihm(satellite).subtit.suivi.choix configure -state disabled
      $astk::ihm(satellite).subtit.suivi.lbl configure -state disabled
   }
   # consquence du choix
   if { $astk::profil(batch) } {
      if { $astk::config($serv,batch) == "oui" } {
         set astk::profil(suivi_interactif) 0
         $astk::ihm(satellite).subtit.suivi.choix configure -state disabled
         $astk::ihm(satellite).subtit.suivi.lbl configure -state disabled
      } else {
         set astk::profil(batch) 0
      }
   } else {
      if { $astk::config($serv,interactif) == "oui" } {
         $astk::ihm(satellite).subtit.suivi.choix configure -state normal
         $astk::ihm(satellite).subtit.suivi.lbl configure -state normal
      } else {
         set astk::profil(batch) 1
      }
   }
   if { $ashare::dbg >= 2 } {
      ashare::log "<DEBUG> (mod_batch) OUT : $astk::profil(batch)"
   }
}

# modif suivi_interactif
#################################################################
proc mod_suivi { } {
   if { $astk::profil(suivi_interactif) } {
      set astk::profil(batch) 0
   }
}

# mise  jour du satellite : liste des noeuds, liste des versions, batch/interactif...
#################################################################
proc maj_sat { } {
   cree_liste_machines
   liste_machines $astk::ihm(satellite).subtit.machine
   if { $astk::ihm(old,sat,0,noeud) == "non_AGLA" } {
      set astk::ihm(old,sat,0,noeud) $astk::ihm(lnoeud,0)
   }
   change_noeud
}

# contenu adapt  l'onglet
#  0 : satellite normal
#  1 : satellite pour agla
#################################################################
proc adapt_satellite { level } {
   global last_level
# si pas de chgt, on sort
   set mod 0
   catch {
      if { $level == $last_level } {
         set mod 1
      } else {
      # conserve les anciennes valeurs
         foreach mcle { noeud memoire temps } {
            set astk::ihm(old,sat,$last_level,$mcle) $astk::profil($mcle)
         }
      }
   }
   if { $mod } { return }

   set last_level $level

   foreach mcle { noeud memoire temps } {
      set astk::profil($mcle) $astk::ihm(old,sat,$level,$mcle)
   }
   switch $level {
      0 {
         $astk::ihm(satellite).subtit.nb_proc.lbl configure -state normal
         $astk::ihm(satellite).subtit.nb_proc.nbp configure -state normal
         $astk::ihm(satellite).subtit.suivi.lbl configure -state normal
         $astk::ihm(satellite).subtit.suivi.choix configure -state normal
         $astk::ihm(satellite).subtit.batch.batch configure -state normal
         $astk::ihm(satellite).subtit.batch.inter configure -state normal
         $astk::ihm(satellite).debug.nodebug configure -state normal
         $astk::ihm(satellite).debug.debug configure -state normal
         change_noeud
         $astk::ihm(satellite).subtit.machine.lbl configure -state normal
         $astk::ihm(satellite).subtit.machine.noeud configure -state normal
      }
      1 {
         $astk::ihm(satellite).subtit.nb_proc.lbl configure -state disabled
         $astk::ihm(satellite).subtit.nb_proc.nbp configure -state disabled
         set astk::profil(suivi_interactif) 0
         $astk::ihm(satellite).subtit.suivi.lbl configure -state disabled
         $astk::ihm(satellite).subtit.suivi.choix configure -state disabled
         set astk::profil(batch) 1
         $astk::ihm(satellite).subtit.batch.batch configure -state disabled
         $astk::ihm(satellite).subtit.batch.inter configure -state disabled
         $astk::ihm(satellite).debug.nodebug configure -state disabled
         $astk::ihm(satellite).debug.debug configure -state disabled
         set astk::profil(serveur) $astk::config($astk::agla(num_serv),nom)
         $astk::ihm(satellite).subtit.machine.lbl configure -state disabled
         $astk::ihm(satellite).subtit.machine.noeud configure -state disabled
         liste_vers_agla $astk::ihm(satellite).subtit.version
	      if { $ashare::dbg >= 3 } {
	      	ashare::log "<DEBUG> (adapt_satellite) Nouveaux serveur/noeud/version : $astk::profil(serveur) $astk::profil(noeud) $astk::profil(version)"
         }
      }
   }
}
