#########################################################################
# COPYRIGHT (C) 2003         EDF R&D              WWW.CODE-ASTER.ORG    #
#                                                                       #
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR         #
# MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS        #
# PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE    #
# LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                       #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,       #
# BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF        #
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      #
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              #
#                                                                       #
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     #
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,       #
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.        #
#########################################################################

# $Id: lance_calcul.tcl,v 1.23 2003/05/15 15:57:23 mcourtoi Exp $

# GO
#################################################################
proc go_calcul { } {
   set nb [ quoi_lancer recap ]
   if { $nb > 0 } {
      ashare::log "====================================\n$recap\n===================================="
      set iret [enregistrer $astk::profil(serv_profil) $astk::profil(nom_profil)]
      if { $iret != 0 } {
         set msg [ashare::mess erreur 13]
         tk_messageBox -message $msg -type ok -icon info
         return 5
      }

      if { $ashare::dbg } {
         ashare::log "<DEBUG> (go_calcul) nom serveur = $astk::profil(serveur)"
   		ashare::log "<DEBUG> (go_calcul) nom noeud   = $astk::profil(noeud)"
      }

   # soumet le calcul
      set iret [ lance_calcul $astk::profil(batch) ]

      if { $iret == 0 } {
         if { $astk::profil(batch) } {
            set msg [ashare::mess ihm 53 [ashare::mess ihm 51]]
         } else {
            set msg [ashare::mess ihm 53 [ashare::mess ihm 52]]
         }
         bell
         #tk_messageBox -message $msg -type ok -icon info
         show_fen $astk::ihm(asjob)
      } elseif { $iret == 2 } {
      # alarmes emises
         set astk::ihm(val_status) [ashare::mess ihm 96]
         tk_messageBox -message [ashare::mess ihm 96] -type ok -icon info
      } elseif { $iret == 3 } {
      # retour de soumission inattendu
         set astk::ihm(val_status) [ashare::mess ihm 97]
         tk_messageBox -message [ashare::mess ihm 97] -type ok -icon info
      } elseif { $iret == 4 } {
      # export failed
         set astk::ihm(val_status) [ashare::mess ihm 104]
         tk_messageBox -message [ashare::mess ihm 104] -type ok -icon info
      } elseif { $iret == 6 } {
      # ajout_job failed
         set astk::ihm(val_status) [ashare::mess ihm 134]
         tk_messageBox -message [ashare::mess ihm 134] -type ok -icon info
      } elseif { $iret == -888 } {
      # code pour exit silencieux car pas de soumission
         set msg [ashare::mess ihm 246]
         set astk::ihm(val_status) $msg
         tk_messageBox -title [ashare::mess ihm 138] -message $msg -type ok -icon info
      } elseif { $iret == -999 } {
      # code pour exit silencieux
         set astk::ihm(val_status) [ashare::mess ihm 12]
      } else {
      # probleme lancement de la commande (as_exec)
         set msg [ashare::mess ihm 60 $iret]
         set astk::ihm(val_status) $msg
         tk_messageBox -title [ashare::mess ihm 138] -message $msg -type ok -icon info
      }
   } else {
      tk_messageBox -message [ashare::mess ihm 61] -type ok -icon info
      set astk::ihm(val_status) [ashare::mess ihm 12]
   }
}

# message rcapitulatif des actions  lancer
#################################################################
proc quoi_lancer { var } {
   upvar $var chaine
   set nb 0
   set chaine "[ashare::mess ihm 63] :\n"
# fonctions agla
   if { $astk::profil(agla) == "oui" } {
      for {set j 2} {$j <= $astk::ihm(nbong,$astk::ihm(nongl_agla)) } {incr j} {
         if { $astk::profil($astk::ihm(ong,$astk::ihm(nongl_agla),$j)) == "oui" } {
            append chaine "  - [ashare::mess ihm 150 $astk::ihm(tit,$astk::ihm(nongl_agla),$j)]\n"
            incr nb
         }
      }
   } else {
# autres fonctions
      if { $astk::profil(etude) == "oui" } {
         append chaine "  - [ashare::mess ihm 64]\n"
         incr nb
      }
      if { $astk::profil(tests) == "oui" } {
         append chaine "  - [ashare::mess ihm 65]\n"
         incr nb
      }
      if { $astk::profil(surcharge) == "oui" } {
         append chaine "  - "
         if { $astk::profil(etude) == "oui" || $astk::profil(tests) == "oui" } {
            append chaine [ashare::mess ihm 66]
         } else {
            append chaine [ashare::mess ihm 67]
         }
         append chaine "\n"
         incr nb
      }
   }
   return $nb
}

# lancement d'un calcul via le service adquat
#################################################################
proc lance_calcul { batch } {
   # batch = 1 : batch
   # batch = 0 : interactif
   set serv $astk::inv(serv,$astk::profil(serveur))
# verif syntaxe de temps, memoire, nbproc
   if { [ conv_tps $astk::profil(temps) ] == 0 } {
      return [ashare::mess ihm 56]
   }
   if { [regexp {^[ ]*([0-9]+)[ ]*} $astk::profil(memoire)] == 0 } {
      return [ashare::mess ihm 58]
   }    
   if { [regexp {^[ ]*([0-9]+)[ ]*} $astk::profil(nb_proc)] == 0 } {
      return [ashare::mess ihm 54]
   }
# verif des limites
   if { $batch } {
      set ch "batch"
   } else {
      set ch "interactif"
   }
   set nb_err 0
# verif temps
   set val $ch
   append val "_tpsmax"
   set val $astk::config($serv,$val)
   if { [ conv_tps $astk::profil(temps)] > $val } {
      return [ashare::mess ihm 57 $val]
   }
# verif memoire
   set val $ch
   append val "_memmax"
   set val $astk::config($serv,$val)
   if { $astk::profil(memoire) > $val } {
      return [ashare::mess ihm 59 $val]
   }
# vrif nb_proc
   set val $ch
   append val "_nbpmax"
   set val $astk::config($serv,$val)
   if { $astk::profil(nb_proc) > $val } {
      return [ashare::mess ihm 55 $val]
   }

# nom du fichier export
   set astk::profil(serv_fich_export) $astk::profil(serv_profil)
   set astk::profil(nom_fich_export) [file rootname $astk::profil(nom_profil)]
   append astk::profil(nom_fich_export) ".export"

# lancement de la commande
   set type astk_serv
   set iret [lance_$type $batch]

   if { $ashare::dbg } {
      ashare::log "<DEBUG> (lance_calcul) iret : $iret"
   }
   return $iret
}

