#########################################################################
# COPYRIGHT (C) 2003         EDF R&D              WWW.CODE-ASTER.ORG    #
#                                                                       #
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR         #
# MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS        #
# PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE    #
# LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                       #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,       #
# BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF        #
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      #
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              #
#                                                                       #
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     #
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,       #
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.        #
#########################################################################

# $Id: remote_tools.tcl,v 1.44 2003/06/23 06:42:59 mcourtoi Exp $

# enrobage pour l'appel au browser multi-machines
# numro du serveur, le chemin+nom, le type (F ou R)
# retourne 0 si ok, 1 sinon
#################################################################
proc ashare::selecteur {srv_OUT dir_OUT typ_OUT srv_IN dir_IN typ_IN {args_sup ""}} {
   upvar $srv_OUT srv
   upvar $dir_OUT dir
   upvar $typ_OUT typ
# voir les serveurs que l'on garde
   set isrv_IN ""
   set k -1
   for { set j -1 } { $j < $astk::config(nb_serv) } { incr j } {
      if { $astk::config($j,etat) == "on" } {
         set cfg($k,num)         $j
         set cfg($k,nom)         $astk::config($j,nom)
         set cfg($k,nom_complet) $astk::config($j,nom_complet)
         set cfg($k,login)       $astk::config($j,login)
         set cfg($k,home)        $astk::config($j,home)
         set cfg($k,xterm)       $astk::config($j,xterm)
         if { $srv_IN == $j } {
            set isrv_IN $k
         }
         if { $ashare::dbg >= 4 } {
            ashare::log "<DEBUG> (selecteur) machine $k : $cfg($k,nom_complet)"
         }
         incr k
      }
   }
   set cfg(nb_serv) $k
# prpare les arguments
   set args ""
   if { $isrv_IN != "" } {
      append args " -initialsrv $isrv_IN"
   }
   if { $dir_IN != "" } {
      append args " -initialdir $dir_IN"
   }
   if { $typ_IN == "" } {
      append args " -typeOut \"FR\""
   } elseif { $typ_IN == "F" } {
      append args " -typeOut \"F\""
   } elseif { $typ_IN == "R" } {
      append args " -typeOut \"R\""
   }
   if { $ashare::dbg } {
      append args " -debug"
      ashare::log "<DEBUG> (selecteur) cfg  : [array get cfg]"
      ashare::log "<DEBUG> (selecteur) args : $args"
   }
   append args " $args_sup"
   set lstemp [eval tkgetdir::tk_getDirectory cfg -font $astk::ihm(font,brwlst) $args]
   set iret 1
   set srv ""
   set dir ""
   set typ ""
   if { [string length [lindex $lstemp 1]] > 0 } {
      set srv $cfg([lindex $lstemp 0],num)
      set dir [lindex $lstemp 1]
      set typ [lindex $lstemp 2]
      set iret 0
      if { $ashare::dbg >= 4 } {
         ashare::log "<DEBUG> (selecteur) iret=$iret ; srv # dir # typ : $srv # $dir # $typ"
      }
   }
   return $iret
}

# substitue des variables avant l'appel  une commande
#   @D = $DISPLAY
#   @F = nom du fichier slectionn (avec le rpertoire)
#   @f = nom du fichier sans le rpertoire
#   @R = rpertoire contenant le fichier slectionn
#################################################################
proc ashare::subst_var { string } {
   set cmd $string
	regsub -all "@D" $cmd $ashare::DISPLAY cmd
   set name $astk::sel(filename)
#   if { $name != "" } {
   set dir  [file dirname $name]
   set base [file tail $name]
	regsub -all "@F" $cmd $name cmd
	regsub -all "@f" $cmd $base cmd
	regsub -all "@R" $cmd $dir cmd
#   }
	return $cmd
}

# excute une commande sur un serveur
# substitue les valeurs des variables utilisateur ventuelles
# -1 reprsente la machine interface
# le tableau de config contient :
# cfg(nserv,nom_complet) et cfg(nserv,login)
# c'est  l'appelant d'mettre ou non un message en fonction du code retour
#################################################################
proc ashare::rexec_cmd { serv cfg prog args bg output {parent ""}} {
   upvar $output msg
   upvar $cfg config
   # on rcupre stdout et stderr dans un fichier unique
   set num [clock clicks -milliseconds]
   set fout [file join $astk::tmpdir .file_rexec_outerr]
   append fout "_$num"
   # vrifier qu'il n'y a pas de redirection dans la commande
   # numero du process : process

# attente
   ashare::pointeur off
# substitution des variables et arguments
   append prog " $args"
	set cmd [ ashare::subst_var $prog ]
# local ?
   if { [ashare::meme_machine $config($serv,nom_complet) $config(-1,nom_complet)]
     && $config($serv,login) == $config(-1,login) } {
      set serv -1
   }
#
   if { $ashare::dbg } {
      ashare::log "<DEBUG> (rexec_cmd) Num serv : $serv / CMD : $cmd"
   }
   if { $serv >= 0 } {
      if { $ashare::dbg } {
         ashare::log "<DEBUG> (rexec_cmd) Remote : rsh -n -l $config($serv,login) $config($serv,nom_complet) + CMD"
      }
      catch { exec rsh -n -l $config($serv,login) $config($serv,nom_complet) $cmd >& $fout & } process
   } else {
      set cmd "exec $cmd >& $fout &"
      catch { eval $cmd } process
   }
# attendre la fin si background non demand
   if { $bg == 0 } {
      if { $ashare::dbg } {
         ashare::log "<DEBUG> (rexec_cmd) Numro du process : $process"
      }
      set ashare::fini($process) 0
      set ashare::cycle($process) 0
      ashare::attend $process $fout $parent
      tkwait variable ashare::fini($process)
   }
# mettre l'output dans msg
   set idf [open $fout r]
   set msg [read -nonewline $idf]
   close $idf
   if { $ashare::dbg < 3 } {
      file delete -force $fout
   }

# code retour renvoy par as_serv dans l'output (car rsh renvoie 0)
   set iret 0
   regexp {EXIT_CODE=([-0-9]+)} $msg mat1 iret
   ashare::pointeur on
   if { $ashare::dbg } {
      ashare::log "<DEBUG> (rexec_cmd) iret : $iret"
   }
   if { $iret == -999 } {
      set ich [tk_messageBox -title [ashare::mess ihm 138] -message [ashare::mess erreur 24] -type ok]
   }
   if { $iret != 0 || $ashare::dbg >= 1 } {
      ashare::log "============== OUTPUT ==============\n$msg\n===================================="
   }
   return $iret
}

# copie de fichiers ou rpertoires direct ou par rcp
# si option=commande, on renvoie la ligne de commande pour faire la copie
#################################################################
proc ashare::rcp_cmd { cfg serv1 fich1 serv2 fich2 option {parent ""}} {
   upvar $cfg config
# attente
   ashare::pointeur off
# local ?
   set serv -1
   set remote 0
   if { [ashare::meme_machine $config($serv1,nom_complet) $config(-1,nom_complet)] != 1
     || $config($serv1,login) != $config(-1,login) } {
      incr remote
   }
   if { [ashare::meme_machine $config($serv2,nom_complet) $config(-1,nom_complet)] != 1
     || $config($serv2,login) != $config(-1,login) } {
      incr remote
   }
#
   if { $remote == 2 } {
      set cmd "rcp -r $config($serv1,login)@$config($serv1,nom_complet):$fich1 $config($serv2,login)@$config($serv2,nom_complet):$fich2"
      set serv $serv1
   } elseif { $remote == 1 } {
      set cmd "rcp -r $config($serv1,login)@$config($serv1,nom_complet):$fich1 $config($serv2,login)@$config($serv2,nom_complet):$fich2"
   } else {
      set cmd "cp -r $fich1 $fich2"
   }
   if { $ashare::dbg } {
      ashare::log "<DEBUG> (rcp_cmd) commande : $cmd"
   }
   if { $option == "commande" } {
      return $cmd
   }

   set iret [ashare::rexec_cmd $serv config $cmd "" 0 out $parent]
   if { $iret != 0 } {
      ashare::mess "erreur" 3 "rcp_cmd de $fich1@$serv1 vers $fich2@$serv2" $iret $out
   }
   ashare::pointeur on
   return $iret
}

# interrompt le process
#################################################################
proc ashare::kill { process fout } {
   set cmd "exec kill -9 $process"
   catch { eval $cmd } out
   # ajoute un exit code dans le fichier output de la commande
   set cmd "exec \\echo EXIT_CODE=-999 >> $fout"
   catch { eval $cmd } out
}

# vrifie que le process tourne encore, sinon ferme la fenetre interrompre
# on cartonne errorCode quand le process est fini (grep)
#################################################################
proc ashare::attend { process fout {parent ""}} {
   incr ashare::cycle($process)
   #ashare::log "<DEBUG> (attend) Process $process, cycle numro : $ashare::cycle($process)"
   set fen "$astk::ihm(interrompre)_$process"
   # on attend le 2me passage avant de faire quoique ce soit
   # sinon on risque de fixer fini=1 avant d'arriver au tkwait
   if { $ashare::cycle($process) > 1 } {
      set cmd "exec /bin/sh -c \"$astk::cmd(ps) -p $process | grep $process | grep -vc grep\""
      catch { eval $cmd } out
      # au cas o le regexp ne trouve rien, on considre que c'est fini
      set nocc 0
      regexp {([0-9]+)} $out mat1 nocc
      if { $nocc != 0 } {
         # on n'affiche la fentre qu' partir du passage N
         if { [winfo exists $fen] == 0
           && $ashare::cycle($process) > 2
           && $parent != "" } {
            toplevel $fen
            wm transient $fen $parent
            wm withdraw $fen
            catch {grab set $fen}
            $fen configure -cursor pirate
            button $fen.int -text [ashare::mess ihm 230] \
               -font $astk::ihm(font,labbout) -background $astk::ihm(couleur,exit) \
               -command "ashare::kill $process $fout ; destroy $fen"
            pack $fen.int
            wm protocol $fen WM_DELETE_WINDOW "$fen.int invoke"
	         ashare::centre_fen $fen $parent
            wm deiconify $fen
         }
      # scrute le process toutes les 100 millisecondes
         after 100 "ashare::attend $process $fout $parent"
      } else {
         set ashare::fini($process) 1
         catch {destroy $fen}
      }
   } else {
      after 50 "ashare::attend $process $fout $parent"
   }
}

# machines identiques ?
# sans le nom de domaine
#################################################################
proc ashare::meme_machine { nom1 nom2 } {
   set iret 0
   # ne rien faire si adresse IP
   if { [regexp {[a-zA-Z]+} $nom1] } {
      regsub -all {\..*$} $nom1 "" nom1
   }
   if { [regexp {[a-zA-Z]+} $nom2] } {
      regsub -all {\..*$} $nom2 "" nom2
   }
   if { $nom1 == $nom2 } {
      set iret 1
   }
   return $iret
}

